/*
	t@C : CDSound.cpp
	e         : CD-DA ։tNX
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.0 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. Audio CD }EgĂȂꍇɎgp
*/
#include <cstring>
#include <limits>
#include "CFSTR.h"
#include "CDSound.h"
#include "CDDA.h"

//static o萔̏
const UInt32				CDSound::kMaxTrackNo     = 99;
const TimeScale				CDSound::kFrameTimeScale = 75;
const SInt16				CDSound::kDefaltVolume   = -1;
const MSFRecord				CDSound::kInvalidTime    = {std::numeric_limits<UInt8>::max(),
														std::numeric_limits<UInt8>::max(),
														std::numeric_limits<UInt8>::max()};

/*
	ANZXw : public
	      ֐ : CDSound::CDSound
	        @\ : ։tNX̃RXgN^
	         : 
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/

CDSound::CDSound(void) throw(std::bad_alloc) : 
    playTrackNo_(0),
    playTrack_(NULL),
    trackRefNum_(0),
    volume_(CDSound::kDefaltVolume),
    pause_(false),
    repeat_(false),
    trackCount_(0),
    hashMap_(CDSound::kMaxTrackNo)
{
	//
	///tԂƑΉgbNt@Cւ̎QƂi[̈̊m
	times_ = static_cast<MSFRecord*>(::CFAllocatorAllocate(kCFAllocatorDefault,
														   CDSound::kMaxTrackNo * sizeof(MSFRecord),
														   0));
	tracks_ = static_cast<FSRefPtr*>(::CFAllocatorAllocate(kCFAllocatorDefault,
														   CDSound::kMaxTrackNo * sizeof(FSRefPtr),
														   0));
	if((NULL == times_) || 
	   (NULL == tracks_))
	{
		///̈̊mۂɎsꍇ
		////mۂ̈悪ΊJAO𓊂
		if(NULL != times_)
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									times_);
		times_  = NULL;
		if(NULL != tracks_)
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									tracks_);
		tracks_ = NULL;
		throw std::bad_alloc();
	}
	///f[^o
	Init();
}

/*
	ANZXw : public
	      ֐ : CDSound::CDSound
	        @\ : ։tNX̃RXgN^
	         : aryTmpls      gbÑev[gi[ꂽ
	                                 CFArrayi zvf CFString jւ̎Q
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
							CDSound::CDSound(CFArrayRef	aryTmpls) throw(std::bad_alloc) : 
							playTrackNo_(0),
							playTrack_(NULL),
							trackRefNum_(0),
							volume_(CDSound::kDefaltVolume),
							pause_(false),
							repeat_(false),
							trackCount_(0),
							hashMap_(CDSound::kMaxTrackNo,
									 aryTmpls)
{
	//
	///tԂƑΉgbNt@Cւ̎QƂi[̈̊m
	times_ = static_cast<MSFRecord*>(::CFAllocatorAllocate(kCFAllocatorDefault,
														   CDSound::kMaxTrackNo * sizeof(MSFRecord),
														   0));
	tracks_ = static_cast<FSRefPtr*>(::CFAllocatorAllocate(kCFAllocatorDefault,
														   CDSound::kMaxTrackNo * sizeof(FSRefPtr),
														   0));
	if((NULL == times_) || 
	   (NULL == tracks_))
	{
		///̈̊mۂɎsꍇ
		////mۂ̈悪ΊJAO𓊂
		if(NULL != times_)
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									times_);
		times_  = NULL;
		if(NULL != tracks_)
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									tracks_);
		tracks_ = NULL;
		throw std::bad_alloc();
	}
	///f[^o
	Init();
}

/*
	ANZXw : virtual, public
	      ֐ : CDSound::~CDSound
	        @\ : ։tNX̃fXgN^
	         : 
	        O : 
	        l : 
*/
							CDSound::~CDSound(void) throw()
{
	///f[^o
	Clear();
	///tԂƑΉgbNt@Cւ̎QƂi[̈̉
	if(NULL != times_)
		::CFAllocatorDeallocate(kCFAllocatorDefault,
								times_);
	times_  = NULL;
	if(NULL != tracks_)
		::CFAllocatorDeallocate(kCFAllocatorDefault,
								tracks_);
	tracks_ = NULL;
}

/*
	ANZXw : public
	      ֐ : CDSound::PlayTrack
	        @\ : CD t[`
	         : ui32TrackNo      tgbNԍ
	      ߂l : noErr    c I
				   paramErr c ui32TrackNo sKȏꍇ
				   ̑   c API ֐̖߂l
	        O : 
	        l : 1. ui32TrackNo ͉̓\ő͈͂ 1 ` 99 ł
				   2. MixedMode CD ̏ꍇAJngbN 2 ł
				   3. }EgĂ Audio CD ɕωLꍇA
				      gbN͍ŐV̏ԂɍXVB
*/
OSErr						CDSound::PlayTrack(UInt32	ui32TrackNo) throw()
{
	//ϐ錾
	OSErr						si16Err;
	HFSUniStr255				hfsDFName;

	//p[^
	if((0 == ui32TrackNo) || 
	   (99 < ui32TrackNo))
		return paramErr;
	if(NULL == tracks_[ui32TrackNo - 1])
		return paramErr;

	//
	///̃gbNtȂ~
	if(NULL != playTrack_)
		StopTrack();
	///gbNt@CJׂ̃p[^̏
    si16Err = ::FSGetDataForkName(&hfsDFName);
    if(noErr != si16Err)
		return si16Err;
	///gbNt@CJ
    si16Err = ::FSOpenFork(tracks_[ui32TrackNo - 1],
    					   hfsDFName.length,
    					   hfsDFName.unicode,
    					   fsRdPerm,
    					   &trackRefNum_);
	if(noErr != si16Err)
	{
		////CD gbNJȂꍇ
		/////CD gbNŐV̏ԂɍXV
		trackRefNum_ = 0;
		try
		{
			Update();
		}
		catch(...)
		{
		}
		/////p[^
		if((0 == ui32TrackNo) || 
		   (99 < ui32TrackNo))
			return paramErr;
		if(NULL == tracks_[ui32TrackNo - 1])
			return paramErr;
		/////ēxgbNt@CJ
	    si16Err = ::FSOpenFork(tracks_[ui32TrackNo - 1],
	    					   hfsDFName.length,
	    					   hfsDFName.unicode,
	    					   fsRdPerm,
	    					   &trackRefNum_);
		if(noErr != si16Err)
		{
			trackRefNum_ = 0;
			return si16Err;
		}
	}
	///[r[t@C쐬
	si16Err = ::NewMovieFromFile(&playTrack_,
								 trackRefNum_,
								 NULL,
								 NULL,
								 newMovieActive,
								 NULL);
	if(noErr != si16Err)
	{
		playTrack_ = NULL;
		::FSCloseFork(trackRefNum_);
		trackRefNum_ = 0;
		return si16Err;
	}
	///CD ʐݒilݒ肳Ăꍇ̂݁j
	if(CDSound::kDefaltVolume != volume_)
		::SetMovieVolume(playTrack_,
						 volume_);
	else
		::SetMovieVolume(playTrack_,
						 kFullVolume);
	///ԃXP[t[i 1 / 75 bjɐݒ
	::SetMovieTimeScale(playTrack_,
						CDSound::kFrameTimeScale);
	///CD tJn
	playTrackNo_ = ui32TrackNo;
	pause_       = false;
	::GoToBeginningOfMovie(playTrack_);
	::StartMovie(playTrack_);
	return noErr;
}

/*
	ANZXw : public
	      ֐ : CDSound::PauseTrack
	        @\ : CD tꎞ~[`
	         : bPause       true c tꎞ~
				                   false c tĊJ
	      ߂l : 
	        O : 
	        l : 
*/
void						CDSound::PauseTrack(bool	bPause) throw()
{
	//p[^
	if(NULL == playTrack_)
		return;

	//
	if(pause_ != bPause)
	{
		if(bPause)
			::StopMovie(playTrack_);
		else
			::StartMovie(playTrack_);
		pause_ = !bPause;
	}
}

/*
	ANZXw : public
	      ֐ : CDSound::StopTrack
	        @\ : CD t~[`
	         : 
	      ߂l : 
	        O : 
	        l : 1. CDSound::PlayTask Ăяop^XNIɌĂяoƁB
*/
void						CDSound::StopTrack(void) throw()
{
	//ϐ錾
	OSErr						si16Err;

	//p[^
	if(NULL == playTrack_)
		return;

	//
	::StopMovie(playTrack_);
	::DisposeMovie(playTrack_);
	si16Err = ::FSCloseFork(trackRefNum_);
	playTrack_   = NULL;
	trackRefNum_ = 0;
	pause_       = false;
	playTrackNo_ = 0;
}

/*
	ANZXw : public
	      ֐ : CDSound::PlayTask
	        @\ : CD t^XN
	         : 
	      ߂l : 
	        O : 
	        l : 1. tJnŒ 0.1 b 1 ͌ĂяoƁB
				      ĂяoȂꍇAt̑s͕s\ɂȂB
*/
void						CDSound::PlayTask(void) throw()
{
	//ϐ錾
	Boolean						bIsNotPlaying;

	//p[^
	if(NULL == playTrack_)
		return;

	//
	bIsNotPlaying = ::IsMovieDone(playTrack_);
	if(FALSE == bIsNotPlaying)
		///t̏ꍇ
		::MoviesTask(playTrack_,
					 0);
	else if(repeat_)
	{
		///JԂtꍇ
		::StopMovie(playTrack_);
		::GoToBeginningOfMovie(playTrack_);
		::StartMovie(playTrack_);
	}
	else
		///tIꍇ
		StopTrack();
}

/*
	ANZXw : public
	      ֐ : CDSound::Update
	        @\ : CD gbNŐV̏ԂɍXV
	         : 
	      ߂l : 
	        O : std::bad_alloci XVɎsꍇ j
	        l : 
*/
void						CDSound::Update(void) throw(std::bad_alloc)
{
	Clear();
	Init();
}

/*
	ANZXw : public
	      ֐ : CDSound::SetVolume
	        @\ : CD ʂݒ肷
	         : si16Vol      ʁi 1 rbgA 7 rbgA 8 rbǧŒ菭j
	      ߂l : 
	        O : 
	        l : 1. ͉\͈͂ 0 ` 1.0 ( 0x0100 ) łB
*/
void						CDSound::SetVolume(SInt16	si16Vol) throw()
{
	//p[^
	if((si16Vol < 0) || 
	   (kFullVolume  < si16Vol))
		return;

	//
	volume_ = si16Vol;
	if(NULL != playTrack_)
		::SetMovieVolume(playTrack_,
						 volume_);
}

/*
	ANZXw : public
	      ֐ : CDSound::GetVolume
	        @\ : CD ʂ𓾂
	         : 
	      ߂l : ʁi 1 rbgA 7 rbgA 8 rbǧŒ菭j
	        O : 
	        l : 1. ߂l 0 ` 1.0 ( 0x0100 ) ̊Ԃ̒lƂ
				   2. l kFullVolumei 1.0 jł
*/
SInt16						CDSound::GetVolume(void) throw()
{
	//ϐ錾
	SInt16						si16Ret;

	//
	if(NULL != playTrack_)
		si16Ret = ::GetMovieVolume(playTrack_);
	else
		si16Ret = static_cast<SInt16>(((CDSound::kDefaltVolume != volume_) ? volume_ : kFullVolume));
	return si16Ret;
}

/*
	ANZXw : public
	      ֐ : CDSound::AudioStatus
	        @\ : CD tԂ𓾂
	         : 
	      ߂l : CD t
				       cdCtrlPlaying    c t
				       cdCtrlPaused     c tꎞ~
				       cdCtrlMuting     c ~[g
				       cdCtrlCompleted  c t
				       cdCtrlError      c G[
				       cdCtrlNotPlaying c t~
	        O : 
	        l : 
*/
CDCtrlAudioState			CDSound::AudioStatus(void) throw()
{
	//
	if(NULL == tracks_)
		return cdCtrlNotPlaying;
	if(NULL == playTrack_)
		return cdCtrlNotPlaying;
	if(FALSE != ::IsMovieDone(playTrack_))
		return cdCtrlNotPlaying;
	if(pause_)
		return cdCtrlPaused;
	if(0 == GetVolume())
		return cdCtrlMuting;
	return cdCtrlPlaying;
}

/*
	ANZXw : public
	      ֐ : CDSound::GetPlayingInfo
	        @\ : t𓾂
	         : ui32PlayTrackPtr   o    ݉t̃gbNԍ
				   msfPlayingTimePtr  o    ݂̉t
	      ߂l : noErr    c I
				   nsvErr   c Audio CD {[}EgĂȂꍇ
				   paramErr c ݉tsĂȂꍇ
	        O : 
	        l : 1. ui32PlayTrackPtr, msfPlayingTimePtr ɂ NULL w\
*/
OSErr						CDSound::GetPlayingInfo(UInt32*		ui32PlayTrackPtr,
													MSFRecord*	msfPlayingTimePtr) throw()
{
	//ϐ錾
	TimeValue					si32PlayingTime;

	//p[^
	if(NULL == tracks_)
		return nsvErr;
	if(NULL == playTrack_)
		return paramErr;

	//
	///݂̉tgbNԍ𓾂
	if(NULL != ui32PlayTrackPtr)
		*ui32PlayTrackPtr = playTrackNo_;
	///݂̉tԂ𓾂
	if(NULL != msfPlayingTimePtr)
	{
		si32PlayingTime = ::GetMovieTime(playTrack_,
										 NULL);
		msfPlayingTimePtr->frames  = static_cast<UInt8>(si32PlayingTime % CDSound::kFrameTimeScale);
		si32PlayingTime /= CDSound::kFrameTimeScale;
		msfPlayingTimePtr->seconds = static_cast<UInt8>(si32PlayingTime % 60L);
		si32PlayingTime /= 60;
		msfPlayingTimePtr->minutes = static_cast<UInt8>(si32PlayingTime);
	}
	return noErr;
}

/*
	ANZXw : public
	      ֐ : CDSound::Repeat
	        @\ : JԂttO𓾂
	         : 
	      ߂l : JԂttO
	        O : 
	        l : 
*/
bool						CDSound::Repeat(void) throw()
{
	//
	///JԂttOԂ
	return repeat_;
}

/*
	ANZXw : public
	      ֐ : CDSound::Repeat
	        @\ : JԂttOݒ肷
	         : value       JԂttO
	      ߂l : 
	        O : 
	        l : 
*/
void						CDSound::Repeat(bool	value) throw()
{
	//
	///JԂttOɒlݒ肷
	repeat_ = value;
}

/*
	ANZXw : public
	      ֐ : CDSound::GetTrackCount
	        @\ : gbN𓾂
	         : 
	      ߂l :       0 c Audio CD {[}EgĂȂ
				   1 ` 99 c gbN
	        O : 
	        l : 1. ). 
	        	        a. ̒l͑։i[fBNg̓eƓĂȂ
	        	        b. CDSound::Update ֐gpɍŐV̏ԂɍXV
*/
UInt32						CDSound::GetTrackCount(void) throw()
{
	//
	return trackCount_;
}

/*
	ANZXw : public
	      ֐ : CDSound::GetTotalTime
	        @\ : tԂ𓾂
	         : 
	      ߂l : 0xFF  0xFF b 0xFF t[ c Audio CD {[}EgĂȂ
				   ̑                        c t
	        O : 
	        l : 1. ). 
	        	        a. ̒l͑։i[fBNg̓eƓĂȂ
	        	        b. CDSound::Update ֐gpɍŐV̏ԂɍXV
*/
MSFRecord					CDSound::GetTotalTime(void) throw()
{
	//ϐ錾
	OSErr						si16Err       = paramErr;
	MSFRecord					msfTime;
	TimeValue					si32TotalTime = 0;

	//
	///tԂ擾ς݂ł邩
	if((CDSound::kInvalidTime.frames  == totalTime_.frames)  && 
	   (CDSound::kInvalidTime.seconds == totalTime_.seconds) && 
	   (CDSound::kInvalidTime.minutes == totalTime_.minutes))
	{
		////擾ĂȂꍇ
		/////tԂt[PʂŎ擾
		for(UInt32	i = 1; i <= trackCount_; i++)
		{
			si16Err = GetTrackInfo(i,
								   &msfTime);
			if(noErr == si16Err)
			{
				si32TotalTime += msfTime.frames;
				si32TotalTime += (     CDSound::kFrameTimeScale * msfTime.seconds);
				si32TotalTime += (60 * CDSound::kFrameTimeScale * msfTime.minutes);
			}
		}
		/////tԂ MSF `ɕϊ
		if(0 < si32TotalTime)
		{
			totalTime_.frames    = static_cast<UInt8>(si32TotalTime % CDSound::kFrameTimeScale);
			si32TotalTime       /= CDSound::kFrameTimeScale;
			totalTime_.seconds   = static_cast<UInt8>(si32TotalTime % 60);
			si32TotalTime       /= 60;
			totalTime_.minutes   = static_cast<UInt8>(si32TotalTime);
		}
	}
	return totalTime_;
}

/*
	ANZXw : public
	      ֐ : CDSound::GetTrackInfo
	        @\ : wgbÑgbN𓾂
	         : ui32TrackNo          gbNԍ
				   msfStartAddrPtr  o    tJnʒu MSF AhX
	      ߂l : noErr    c I
				   paramErr c ͈͊ÕgbNԍw肵ꍇ
	        O : 
	        l : 1. ui32TrackNo ͉̓\ő͈͂ 1 ` 99 ł
	               2. ). 
	        	        a. ̒l͑։i[fBNg̓eƓĂȂ
	        	        b. CDSound::Update ֐gpɍŐV̏ԂɍXV
*/
OSErr						CDSound::GetTrackInfo(UInt32		ui32TrackNo,
												  MSFRecord*	msfStartAddrPtr) throw()
{
	//ϐ錾
	OSErr						si16Err          = paramErr;
	HFSUniStr255				hfsDFName;
	MSFRecord*					msfi             = NULL;
	SInt16						si16RefNum       = 0;
	Movie						movTrack         = NULL;
	TimeValue					si32Frames;

	//p[^
	if((0 == ui32TrackNo) || 
	   (99 < ui32TrackNo))
		return si16Err;
	if(NULL == tracks_[ui32TrackNo - 1])
		return si16Err;
	if(NULL == msfStartAddrPtr)
		return si16Err;

	//
	///gbN񂪎擾ς݂ł邩
	msfi = &(times_[ui32TrackNo - 1]);
	if((CDSound::kInvalidTime.frames  != msfi->frames)  || 
	   (CDSound::kInvalidTime.seconds != msfi->seconds) || 
	   (CDSound::kInvalidTime.minutes != msfi->minutes))
	{
		////擾ς݂̏ꍇ
		*msfStartAddrPtr = *msfi;
		si16Err = noErr;
	}
	else
	{
		////擾ĂȂꍇ
		/////gbN擾
		if(noErr == si16Err)
			si16Err = ::FSGetDataForkName(&hfsDFName);
		if(noErr == si16Err)
			si16Err = ::FSOpenFork(tracks_[ui32TrackNo - 1],
								   hfsDFName.length,
								   hfsDFName.unicode,
								   fsRdPerm,
								   &si16RefNum);
		if(noErr == si16Err)
			si16Err = ::NewMovieFromFile(&movTrack,
										 si16RefNum,
										 NULL,
										 NULL,
										 newMovieActive,
										 NULL);
		if(noErr == si16Err)
		{
			::SetMovieTimeScale(movTrack,
								CDSound::kFrameTimeScale);
			si32Frames = ::GetMovieDuration(movTrack);
			msfi->frames   = static_cast<UInt8>(si32Frames % CDSound::kFrameTimeScale);
			si32Frames    /= CDSound::kFrameTimeScale;
			msfi->seconds  = static_cast<UInt8>(si32Frames % 60);
			si32Frames    /= 60;
			msfi->minutes  = static_cast<UInt8>(si32Frames);
		}
		if(NULL != movTrack)
			::DisposeMovie(movTrack);
		if(0 != si16RefNum)
			si16Err = ::FSCloseFork(si16RefNum);
		if(noErr == si16Err)
			*msfStartAddrPtr = *msfi;
	}
	return si16Err;
}

/*
	ANZXw : private
	      ֐ : CDSound::Init
	        @\ : CDSound IuWFNg֐
	         : 
	      ߂l : 
	        O : std::bad_alloci Ɏsꍇ j
	        l : 1. O playTrackNo_, repeat_, volume_, times_, tracks_ Soϐ
				      NULL, 0 ŏĂƁB
				      iȂꍇACDSound IuWFNg̃fXgN^ł͖̓`j
				   2. ։̓AvP[VƓKwɂ "CD-DA" fBNgɂƉ肷
				   3. AvP[VƓKw "CD-DA" fBNg݂ȂꍇA
				      ։̓AvP[VƓKwɂƉ肷
				   4. ։̂́Âǂꂩƈv邱ƁB
							a). "<gbNԍiϒj>"    ).  1,  2, 11, ...
							b). "<gbNԍ>"              ). 01, 02, 11, ...
							c). "Track <gbNԍ>"        ). Track 01     , Track 02     , ...
							d). "Track <gbNԍ>.mp3"    ). Track 01.mp3 , Track 02.mp3 , ...
							e). "Track <gbNԍ>.cdda"   ). Track 01.cdda, Track 02.cdda, ...
							f). "Track <gbNԍ>.aiff"   ). Track 01.aiff, Track 02.aiff, ...
							g). "Track <gbNԍ>.wave"   ). Track 01.wave, Track 02.wave, ...
							h). "Track <gbNԍ>.aif"    ). Track 01.aif , Track 02.aif , ...
							i). "Track <gbNԍ>.wav"    ). Track 01.wav , Track 02.wav , ...
				   5. <gbNԍ> ͕K 2 ɂ邱Ɓi1 ` 9 ̏ꍇ́A01, 02, ... Ƃj
*/
void						CDSound::Init(void) throw(std::bad_alloc)
{
	//ϐ錾
	OSErr						si16Err;
	ProcessSerialNumber			psn = { 0, kCurrentProcess };
	FSRef						fsApp;
	FSRef						fsAppDir;
	FSRef						fsCDDADir;
	CFURLRef					urlAppDir    = NULL;
	CFURLRef					urlCDDADir   = NULL;
	Boolean						bRet;
	Boolean						bIsDir;
	Boolean						bIsAlias;
	FSIterator					fsi          = NULL;
	FSCatalogInfo				fsItemInfo;
	FSRef						fsTemp;
	ItemCount					ui32Count;
	CFURLRef					urlTemp      = NULL;
	CFStringRef					strTemp      = NULL;
	UInt32						ui32TrackNo;
	bool						bFound;
	FSRef**						fsri         = NULL;

	//
	try
	{
		///oϐ̏
		std::memset(&totalTime_,
					static_cast<int>(std::numeric_limits<unsigned int>::max()),
					sizeof(MSFRecord));
		std::memset(times_,
					static_cast<int>(std::numeric_limits<unsigned int>::max()),
					CDSound::kMaxTrackNo * sizeof(MSFRecord));
		::BlockZero(tracks_,
					CDSound::kMaxTrackNo * sizeof(FSRefPtr));
		///։i[fBNgւ FSRef 𓾂
		////AvP[VCXg[fBNgւ FSRef 𓾂
		si16Err = GetProcessBundleLocation(&psn, &fsApp); 
		if(noErr != si16Err)
			throw std::bad_alloc();
		
		si16Err = ::FSGetCatalogInfo(&fsApp,
									 kFSCatInfoNone,
									 NULL,
									 NULL,
									 NULL,
									 &fsAppDir);
		if(noErr != si16Err)
			throw std::bad_alloc();
		////AvP[VCXg[fBNgւ̐΃pX𓾂
		urlAppDir = ::CFURLCreateFromFSRef(kCFAllocatorDefault,
										   &fsAppDir);
		if(NULL == urlAppDir)
			throw std::bad_alloc();
		////CD-DA fBNgւ̐΃pX𓾂
		urlCDDADir = ::CFURLCreateCopyAppendingPathComponent(kCFAllocatorDefault,
															 urlAppDir,
															 CFSTR("CD-DA"),
															 TRUE);
		////։i[fBNgւ FSRef 𓾂
		////iGCAXł΁AIWiւ FSRef ɕϊj
		bRet = FALSE;
		if(NULL != urlCDDADir)
			bRet = ::CFURLGetFSRef(urlCDDADir,
								   &fsCDDADir);
		if(TRUE == bRet)
		{
			si16Err = ::FSResolveAliasFile(&fsCDDADir,
										   TRUE,
										   &bIsDir,
										   &bIsAlias);
			bRet = (noErr == si16Err);
		}
		////։i[fBNg݂ȂꍇA
		////AvP[ṼCXg[fBNg։i[fBNgƂ݂Ȃ
		if(FALSE == bRet)
			fsCDDADir = fsAppDir;
		////΃pX̉
		::CFRelease(urlAppDir);
		urlAppDir  = NULL;
		if(NULL != urlCDDADir)
			::CFRelease(urlCDDADir);
		urlCDDADir = NULL;
		////։i[fBNgւ̐΃pX𓾂
		urlCDDADir = ::CFURLCreateFromFSRef(kCFAllocatorDefault,
											&fsCDDADir);
		if(NULL == urlCDDADir)
			throw std::bad_alloc();
		///։ꗗ̍쐬pp[^̏
		trackCount_   = 0;
		///։񋓂
		////t@C񋓗pCe[^̍쐬
		si16Err = ::FSOpenIterator(&fsCDDADir,
								   kFSIterateFlat,
								   &fsi);
		if(noErr != si16Err)
			throw std::bad_alloc();
		////t@C񋓊Jn
		while(true)
		{
			/////p[^̏
			fsItemInfo.nodeFlags = 0;
			::BlockZero(&fsTemp,
						sizeof(FSRef));
			urlTemp     = NULL;
			strTemp     = NULL;
			ui32TrackNo = 0;
			fsri        = NULL;
			bRet        = FALSE;
			/////t@C񋓂
			/////i񋓍ڂt@CfBNg肷邽߂ɁAJ^O nodeFlags o𓾂j
			si16Err = ::FSGetCatalogInfoBulk(fsi,
											 1,
											 &ui32Count,
											 NULL,
											 kFSCatInfoNodeFlags,
											 &fsItemInfo,
											 &fsTemp,
											 NULL,
											 NULL);
			if(errFSNoMoreItems == si16Err)
				break;
			else if(noErr != si16Err)
				throw std::bad_alloc();
			/////񋓍ڂt@Cł邩
			if(0 == (fsItemInfo.nodeFlags & kFSNodeIsDirectoryMask))
			{
				/////񋓍ڂt@C̏ꍇ
				//////񋓃t@Cւ̐΃pX𓾂
				urlTemp = ::CFURLCreateFromFSRef(kCFAllocatorDefault,
												 &fsTemp);
				if(NULL == urlTemp)
					throw std::bad_alloc();
				//////񋓃t@Ĉ CFString œ
				strTemp = ::CFURLCopyLastPathComponent(urlTemp);
				if(NULL == strTemp)
					throw std::bad_alloc();
				//////񋓃t@C։i͑։ւ̃GCAXjł邩
				bFound = hashMap_.itemIfExists(strTemp,
											   ui32TrackNo);
				//////gp CFObject ̉
				::CFRelease(strTemp);
				::CFRelease(urlTemp);
				//////񋓃t@CGCAXłΎQƉs
				if(bFound)
				{
					si16Err = ::FSResolveAliasFile(&fsTemp,
												   TRUE,
												   &bIsDir,
												   &bIsAlias);
					bFound = (noErr == si16Err);
				}
				if(bFound)
				{
					//////񋓃t@C։i͑։ւ̃GCAXj̏ꍇ
					///////։̐ݒ
					fsri  = &tracks_[ui32TrackNo - 1];
					*fsri = static_cast<FSRefPtr>(::CFAllocatorAllocate(kCFAllocatorDefault,
																		sizeof(FSRef),
																		0));
					if(NULL != fsri)
					{
						**fsri = fsTemp;
						++trackCount_;
					}
				}
			}
		}
		////t@C񋓗pCe[^̉
		si16Err = ::FSCloseIterator(fsi);
		fsri = NULL;
		////։i[fBNgւ̐΃pX̉
		::CFRelease(urlCDDADir);
    }
    catch(...)
    {
		if(NULL != urlAppDir)
			::CFRelease(urlAppDir);
		if(NULL != urlCDDADir)
			::CFRelease(urlCDDADir);
		if(NULL != fsi)
			si16Err = ::FSCloseIterator(fsi);
		if(NULL != urlTemp)
			::CFRelease(urlTemp);
		if(NULL != strTemp)
			::CFRelease(strTemp);
		Clear();
    	throw;
    }
}

/*
	ANZXw : private
	      ֐ : CDSound::Clear
	        @\ : CDDriver_CFM IuWFNg֐
	         : 
	      ߂l : 
	        O : 
	        l : 1. playTrackNo_, repeat_, volume_ Soϐ NULL, 0 ŏ邱ƁB
				      iȂꍇACDDriver_CFM::Update ֐͖̓`j
*/
void				CDSound::Clear(void) throw()
{
	//
	///t̏
	if(NULL != playTrack_)
		StopTrack();
	///gbNꗗ̉
	if(NULL != tracks_)
	{
		for(UInt32 i = 1; i <= CDSound::kMaxTrackNo; i++)
		{
			if(NULL != tracks_[i - 1])
				::CFAllocatorDeallocate(kCFAllocatorDefault,
										tracks_[i - 1]);
			tracks_[i - 1] = NULL;
		}
	}
}