/*
	t@C : CDDriver.h
	e         : CD Driver ʃC^[tF[X
	     : S
	l         : 
*/
#ifndef __CDDRIVER__
#define __CDDRIVER__

#ifndef __CARBON__
#include <Carbon.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
  Classic CD Driver CDStatus ^ audioStatus o̗񋓒萔
      cdCtrlPlaying   (= 0) : t
      cdCtrlPaused    (= 1) : tꎞ~
      cdCtrlMuting    (= 2) : ~[g
      cdCtrlCompleted (= 3) : t
      cdCtrlError     (= 4) : G[
      cdCtrlNotPlaying(= 5) : t~
*/
enum CDCtrlAudioState
{
	cdCtrlPlaying    = 0,
	cdCtrlPaused     = 1,
	cdCtrlMuting     = 2,
	cdCtrlCompleted  = 3,
	cdCtrlError      = 4,
	cdCtrlNotPlaying = 5
};
typedef enum CDCtrlAudioState		CDCtrlAudioState;

/*
  MSF ^
      minutes : 
      seconds : b
      frames  : t[i= 1/75 bj
*/
struct MSFRecord
{
	UInt8					minutes;
	UInt8					seconds;
	UInt8					frames;
};
typedef struct MSFRecord			MSFRecord;

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus

///CC֐
/*
	      ֐ : ::MSFToBlockAddr
	        @\ : MSF AhX -> 32 bit ubNAhXϊ
	         : MSF      MSF AhX
	      ߂l : 32 bit ubNAhX
	        O : 
	        l : 
*/
inline UInt32			MSFToBlockAddr(MSFRecord	MSF)
{
    return (75UL * ((60UL * MSF.minutes) + MSF.seconds)) + MSF.frames + 150UL;
};

/*
	      ֐ : ::MSFToBlockAddr
	        @\ : 32 bit ubNAhX -> MSF AhXϊ
	         : Block      32 bit ubNAhX
				   MSFPtr o    MSF AhX
	      ߂l : 
	        O : 
	        l : 
*/
inline void				BlockToMSFAddr(UInt32		Block,
									   MSFRecord*	MSFPtr)
{
	//ϐ錾
	UInt32					ui32Temp = Block;

	//
	ui32Temp        -= 150;
	MSFPtr->frames   = static_cast<UInt8>(ui32Temp % 75UL);
	ui32Temp        -= MSFPtr->frames;
	ui32Temp        /= 75UL;
	MSFPtr->seconds  = static_cast<UInt8>(ui32Temp % 60UL);
	ui32Temp        -= MSFPtr->seconds;
	ui32Temp        /= 60UL;
	MSFPtr->minutes  = static_cast<UInt8>(ui32Temp);
};

#else

/*#define }N*/
/*
	    }N : MSFToBlockAddr
	        @\ : MSF AhX -> 32 bit ubNAhXϊ
	         : MSF      MSF AhX
	      ߂l : 32 bit ubNAhX
	        O : 
	        l : 
*/
#define MSFToBlockAddr(MSF)			((75UL * ((60UL * (MSF).minutes) + (MSF).seconds)) + (MSF).frames - 150UL)

/*
	    }N : BlockToMSFAddr
	        @\ : 32 bit ubNAhX -> MSF AhXϊ
	         : arg1      32 bit ubNAhX
				   arg2  o    MSF AhX
	      ߂l : 
	        O : 
	        l : 1. ̃}NĂяo֐ ui32Temp_, MSFPtr_ ϐɎgpȂ
*/
#define BlockToMSFAddr(arg1, arg2)					\
{													\
	UInt32					ui32Temp_ = (arg1);		\
	MSFRecord*				MSFPtr_   = (arg2);		\
													\
	ui32Temp_        -= 150;						\
	MSFPtr_->frames   = (UInt8)(ui32Temp_ % 75UL);	\
	ui32Temp_        -= MSFPtr_->frames;			\
	ui32Temp_        /= 75UL;						\
	MSFPtr_->seconds  = (UInt8)(ui32Temp_ % 60UL);	\
	ui32Temp_        -= MSFPtr_->seconds;			\
	ui32Temp_        /= 60UL;						\
	MSFPtr_->minutes  = (UInt8)ui32Temp_;			\
}

#endif

#endif	/*__CDDRIVER__*/