/*
	t@C : CDDA.cpp
	e         : Mac OS 9.x / Mac OS X p CDDA tNXC^[tF[X
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.2 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. CDDA IuWFNggp@
				       a). CDDA IuWFNg쐬
				             CDDA::Create() ֐gp
				             sɉ CD-DA tIuWFNg쐬B

				       b). CDDA IuWFNgj
				              delete gpāACDDA::Create() ֐œꂽ
				              CDDA IuWFNgւ̃|C^jB

				       c). gp̒
				               ECDDA IuWFNg 2 ȏ쐬ꍇ͖̓`
				               Et͒Ii : 0.05 b  1 j CDDA::Task ֐
				                 ĂяoƁB
				                 ĂяoȂꍇAt~܂AJԂtłȂA
				                 ̕sB

				       d). ̑
				               ECDDA::Create() ֐ǂ΁A
				                 Audio CD }EgĂȂꍇ͑։gpA
				                 ƂgݍނƂ\B
				                 ̏ꍇA։t[` CDDA ̃TuNXA
				                 CDDA NX̃o֐݊̃NXɂKvLB
				                 i쐬ꍇɂ CDDA.cpp  CDDA_Classic, CDDA_X Ql̎j
*/
#include "CDDA.h"
#include "VersionUtilities.h"
#include "CDSound.h"

OSType	CDDA::kAudioCDSignature = 'J' << 8 | 'H';


//։tNX
class CDDA_Other : public CDDA
{
	public :
									CDDA_Other(CFArrayRef = NULL)  throw(std::bad_alloc);
		virtual						~CDDA_Other(void) throw();
		virtual OSStatus			Play(UInt32)  throw();
		virtual void				Pause(bool)   throw();
		virtual void				Stop(void)    throw();
		virtual void				Task(void)    throw();
		virtual UInt32				Volume(void)  throw();
		virtual void				Volume(UInt32) throw();
		virtual CDCtrlAudioState	AudioStatus(void) throw();
		virtual OSStatus			PlayingInfo(UInt32*,
												MSFRecord*) throw();
		virtual bool				Repeat(void) throw();
		virtual void				Repeat(bool) throw();
		virtual bool				MixedMode(void)  throw();
		virtual UInt32				TrackCount(void) throw();

	private :
									CDDA_Other(const CDDA_Other&);
		const CDDA_Other&			operator=(const CDDA_Other&);
		//f[^o`
		CDSound						_drvr;
};

/*
	ANZXw : static, public
	      ֐ : CDDA::Mounted
	        @\ : CD-DA {[}EgĂ邩
	         : fsCDVolPtr  o    ŏɌ CD-DA {[ւ̎Q
	      ߂l : true  c CD-DA {[̓}Eg
				   false c CD-DA {[̓}EgĂȂ
	        O : 
	        l : 1. Mac OS 8.6  MixedModeCD ̏ꍇAOS ̎dlŏ false Ԃi؁j
				      iR : fXNgbv Audio CD {[}EgȂ߁j
				   2. fsCDVolPtr ɂ NULL w\
				   3. ). 
				      Audio CD }EgĂꍇA
				      2 Ԗڈȍ~ Audio CD {[ւ̎QƂ͊lłȂ
*/
bool						CDDA::Mounted(FSRef*	fsCDVolPtr) throw()
{
	//ϐ錾
	OSStatus					si32Err;	///::FSGetVolumeInfo() API ֐߂l
	ItemCount					ui32Loop;
	FSVolumeInfo				VolInfo;
	FSRef						fsCDVol;
	bool						bRet;

	//
	bRet = false;
	ui32Loop = 1;
	while(noErr == si32Err || nsvErr != si32Err)
	{
		///{[̃[gfBNg FSRef 𓾂
		VolInfo.filesystemID = NULL;
		VolInfo.signature    = NULL;
		si32Err = ::FSGetVolumeInfo(kFSInvalidVolumeRefNum,
									ui32Loop,
									NULL,
									kFSVolInfoFSInfo,
									&VolInfo,
									NULL,
									&fsCDVol);
		////Audio CD {[Ȃ烋[v𔲂
		////).
        //// Work around a bug in Mac OS X 10.0.x where the filesystem ID and signature bytes were
        //// erroneously swapped. This was fixed in Mac OS X 10.1 (r. 2653443).
		if((noErr == si32Err) && 
		   ((CDDA::kAudioCDSignature == VolInfo.filesystemID) || 
		    (CDDA::kAudioCDSignature == VolInfo.signature)))
		{
		 	bRet = true;
		 	break;
		}
		++ui32Loop;
	}
	if(NULL != fsCDVolPtr)
		*fsCDVolPtr = fsCDVol;
	return bRet;
}

/*
	ANZXw : static, public
	      ֐ : CDDA::Create
	        @\ : CD-DA tIuWFNg̍쐬
	         : aryTmpls      ։gbÑev[gꗗ
	               iȗ\j
	      ߂l : CD-DA tIuWFNgւ̃|C^
	        O : std::bad_alloci CD-DA tIuWFNg̍쐬Ɏsꍇ j
	        l : 1. s OS ̎ނ𔻒肵AK؂ȃIuWFNg쐬
				   2. IuWFNggp delete ŉ邱
*/
CDDA*	CDDA::Create(CFArrayRef	aryTmpls) throw(std::bad_alloc)
{
	//ϐ錾
	CDDA*	cdObj          = NULL;
	UInt32	ui32TrackCount = 0;
        
	///CD-DA tIuWFNg̍쐬
	try
	{
            //Mac OS X p
            cdObj = new CDDA_Other;
	}
	catch(...)
	{
		cdObj = NULL;
	}
	///Audio CD }EgĂ邩
	if(NULL != cdObj)
		ui32TrackCount = cdObj->TrackCount();

	///Audio CD }EgĂȂꍇ̂ݑ։gp
	if((0   == ui32TrackCount) || (100 <= ui32TrackCount))
	{
		if(NULL != cdObj)
			delete cdObj;
		cdObj = new CDDA_Other(aryTmpls);
	}
	return cdObj;
}


#pragma mark -- ։ --
/*
	ANZXw : public
	      ֐ : CDDA_Other::CDDA_Other
	        @\ : Mac OS X p CD-DA tNX̃RXgN^
	         : 
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
							CDDA_Other::CDDA_Other(CFArrayRef	aryTmpls) throw(std::bad_alloc) : 
							_drvr(aryTmpls)
{
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::~CDDA_Other
	        @\ : Mac OS X p CD-DA tNX̃fXgN^
	         : 
	        O : 
	        l : 
*/
							CDDA_Other::~CDDA_Other(void) throw()
{
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::Play
	        @\ : CD-DA t[`
	         : ui32TrackNo      tJngbNԍ
	      ߂l : noErr    c I
				   paramErr c ui32TrackNo sKȏꍇ
				   ̑   c API ֐̖߂l
	        O : 
	        l : 1. ui32TrackNo ͉̓\ő͈͂ 1 ` 99 ł
				   2. Mixed Mode CD ̏ꍇAJngbN 2 ł
*/
OSStatus					CDDA_Other::Play(UInt32	ui32TrackNo) throw()
{
	//
	return _drvr.PlayTrack(ui32TrackNo);
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::Pause
	        @\ : CD-DA tꎞ~^ĊJ[`
	         : bPause       true c ꎞ~
				                   false c tĊJ
	      ߂l : 
	        O : 
	        l : 
*/
void						CDDA_Other::Pause(bool	bPause) throw()
{
	//
	_drvr.PauseTrack(bPause);
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::Stop
	        @\ : CD-DA t~[`
	         : 
	      ߂l : 
	        O : 
	        l : 
*/
void						CDDA_Other::Stop(void) throw()
{
	//
	_drvr.StopTrack();
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_X::Task
	        @\ : CD-DA t^XN
	         : 
	      ߂l : 
	        O : 
	        l : 1. JԂtsꍇAŒł 0.1 b 1 ͌ĂяoƁB
				      iĂяoȂꍇACD t͑słȂȂ܂j
*/
void						CDDA_Other::Task(void) throw()
{
	//
	_drvr.PlayTask();
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_X::Volume
	        @\ : CD ʂ𓾂
	         : 
	      ߂l : 
	        O : 
	        l : ʂ 0 ` 256 ͈̔͂̒lƂ
*/
UInt32						CDDA_Other::Volume(void) throw()
{
	//
	return static_cast<UInt32>(_drvr.GetVolume());
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_X::Volume
	        @\ : CD ʂݒ肷
	         : ui32Vol      CD 
	      ߂l : 
	        O : 
	        l : 1. ui32Vol ͉̓\͈͂ 0 ` 256 ܂łłB
*/
void						CDDA_Other::Volume(UInt32	ui32Vol) throw()
{
	//
	_drvr.SetVolume(static_cast<SInt16>(ui32Vol));
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::AudioStatus
	        @\ : CD tԂ𓾂
	         : 
	      ߂l : CD t
				       cdCtrlPlaying    c t
				       cdCtrlPaused     c tꎞ~
				       cdCtrlMuting     c ~[g
				       cdCtrlNotPlaying c t~
	        O : 
	        l : 
*/
CDCtrlAudioState			CDDA_Other::AudioStatus(void) throw()
{
	//
	return _drvr.AudioStatus();
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::PlayingInfo
	        @\ : CD t𓾂
	         : ui32TrackPtr  o    tgbNԍ
				   msfTimePtr    o    ݂̉t
	      ߂l : noErr    c I
				   paramErr c ݉tsĂȂꍇ
	        O : 
	        l : 1. ֐߂l noErr ̏ꍇAui32TrackPtr ɂ 1 ` 99 ͈͓̔̒lԂ
*/
OSStatus					CDDA_Other::PlayingInfo(UInt32*		ui32TrackPtr,
													MSFRecord*	msfTimePtr) throw()
{
	//
	return _drvr.GetPlayingInfo(ui32TrackPtr,
								msfTimePtr);
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::Repeat
	        @\ : JԂttO𓾂
	         : 
	      ߂l : JԂttO
	        O : 
	        l : 
*/
bool						CDDA_Other::Repeat(void) throw()
{
	//
	return _drvr.Repeat();
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::Repeat
	        @\ : JԂttOݒ肷
	         : value      JԂttO
	      ߂l : 
	        O : 
	        l : 
*/
void						CDDA_Other::Repeat(bool	value) throw()
{
	//
	_drvr.Repeat(value);
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::MixedMode
	        @\ : MixedMode CD 肷
	         : 
	      ߂l :  false
	        O : 
	        l : 
*/
bool						CDDA_Other::MixedMode(void) throw()
{
	return false;
}

/*
	ANZXw : virtual, public
	      ֐ : CDDA_Other::TrackCount
	        @\ : gbN𓾂
	         : 
	      ߂l : 1 ` 99 c gbN
				   0       c G[
	        O : 
	        l : 1. gbN̍ől 99 ł
*/
UInt32						CDDA_Other::TrackCount(void) throw()
{
	return _drvr.GetTrackCount();
}