/*
	t@C : CFMDrawSprocket.h
	e         : Mac OS 9.x / Mac OS X ptXN[[`i DrawSprocket gpj
	     : Mac OS 9.x : DrawSprocket Version 1.0  ȍ~
				   Mac OS X   : DrawSprocket Version 1.99 ȍ~i Mac OS X 10.0.3 ȍ~ j
	l         : 1. DSpBeginFullScreen, DSpEndFullScreen ĂяoO DSpStartup API ֐
				      Ăяo
				   2. tXN[́ACxg[v WaitNextEvent API ֐ĂяoA
				      kCxgłȂ DSpProcessEvent API ֐Ăяo
				   3. AvP[VIO DSpShutdown API ֐Ăяo
*/
#include "DSpFullScreen.h"
#include "VersionUtilities.h"

/*^`*/
/*XN[Ԍ^*/
struct _FullScreenStatus
{
	DSpContextReference								context;
	WindowRef										screen;
};
typedef struct _FullScreenStatus				_FullScreenStatus;

/*
	      ֐ : DSpBeginFullScreen
	        @\ : tXN[
	         : ui32Width                tXN[ʂ̕
				   ui32Height               tXN[ʂ̍
				   ui32BitsPerPixel         tXN[ʂ̃rbg[x
				                                i 16  32 Ij
				   RGB_ERASE_COLOR_PTR      tXN[ʂ̏wiF
				   enmFlags                 tXN[tO
				       0                       c J[\\
				       dspFullScreenHideCursor c J[\B
				   wFullScreenPtr       o    tXN[ʂւ̎Q
				   screenStatePtr       o    XN[Ԃւ̎Q
	      ߂l :    noErr : I
				   paramErr : wFullScreenPtr,  screenStatePtr Ƀk|C^n
				   ̑   : G[
	        l : 1. ߂l noErr ȊȌꍇAtXN[Ȃ
				   2. ߂l noErr, paramErr ȊȌꍇAwFullScreenPtr, screenStatePtr ɂ
				      k|C^Ԃ
				   3. AvP[VIOɕK DSpEndFullScreen ĂяoA
				      tXN[ʂ邱
				   4. tXN[ꍇAj[o[͎IɉB
				   5. ). Mac OS X ł́AtXN[}EXɂ郁j[o[NbN͔Ȃ
				             iL[{[hV[gJbg͔j
*/
OSStatus										DSpBeginFullScreen(UInt32				ui32Width,
																   UInt32				ui32Height,
																   UInt32				ui32BitsPerPixel,
																   const RGBColor*		RGB_ERASE_COLOR_PTR,
																   DSpFullScreenFlag	enmFlags,
																   WindowRef*			wFullScreenPtr,
																   FullScreenStatusRef*	screenStatePtr)
{
	/*ϐ錾*/
	static Boolean									bIsOSX            = FALSE;
	static Boolean									bIsClassic        = FALSE;
	Boolean											bIsCreated        = FALSE;
	Boolean											bFadeOut          = FALSE;
	Boolean											bIsActive         = FALSE;
	Boolean											bIsPaused         = FALSE;
	OSStatus										si32Err           = noErr;
	NumVersion										versDSp;
	DSpContextAttributes							contextAttributes;
	DSpContextAttributes							foundAttributes;
	FullScreenStatusRef								screenState       = NULL;
	RGBColor										rgbEraseColor     = {0, 0, 0};
	DisplayIDType									displayID         = 0;
	GDHandle										hGDevice          = NULL;
	GDHandle										hGDSave;
	GWorldPtr										gwGrafSave;
	RGBColor										rgbSave;
	Rect											rcWin;
	Rect											rcPaint;

	/*p[^*/
	if(NULL == wFullScreenPtr)
		return paramErr;
	if(NULL == screenStatePtr)
		return paramErr;

	/**/
	/*sî݁j*/
	if((FALSE == bIsOSX) && 
	   (FALSE == bIsClassic))
	{
		bIsOSX     = RunningMacOSX();
		bIsClassic = (Boolean)(bIsOSX ? RunningClassic() : TRUE);
		bIsOSX     = (Boolean)(bIsOSX ? !bIsClassic      : FALSE);
	}
	/*tXN[Ԋi[p̈̊mۋyя*/
	screenState = (FullScreenStatusRef)(CFAllocatorAllocate(kCFAllocatorDefault,
															(CFIndex)(sizeof(_FullScreenStatus)),
															0));
	if(NULL == screenState)
		return coreFoundationUnknownErr;
	BlockZero(screenState,
			  (Size)(sizeof(_FullScreenStatus)));
	/*DrawSprocket o[W`FbNi Mac OS X ̂ j*/
	if(FALSE != bIsOSX)
	{
		if(noErr == si32Err)
		{
			versDSp = DSpGetVersion();
			if((0x00 == versDSp.majorRev) && 
			   (0x00 == versDSp.minorAndBugRev))
				si32Err = paramErr;
		}
		if(noErr == si32Err)
		{
			if((versDSp.majorRev       == 0x01) && 
			   (versDSp.minorAndBugRev  < 0x99))
				si32Err = paramErr;
		}
	}

	/*DSpContext 쐬*/
	if(noErr == si32Err)
	{
		/* : DrawSprocket 1.7.3 ȑȌꍇA
		         obNobt@̓tgobt@݂̂̏ꍇłݒ肷邱*/
		BlockZero(&contextAttributes,
				  sizeof(DSpContextAttributes));
		contextAttributes.displayWidth		  = ui32Width;
		contextAttributes.displayHeight	      = ui32Height;
		contextAttributes.colorNeeds		  = kDSpColorNeeds_Require;
		contextAttributes.displayBestDepth	  = ui32BitsPerPixel;
		contextAttributes.backBufferBestDepth = ui32BitsPerPixel;
		contextAttributes.displayDepthMask	  = kDSpDepthMask_All;
		contextAttributes.backBufferDepthMask = kDSpDepthMask_All;
		contextAttributes.pageCount			  = 1;
		si32Err = DSpFindBestContext(&contextAttributes,
									 &(screenState->context));
	}
	/*DSpContext ̔wiFݒ*/
	if(noErr == si32Err)
	{
		bIsCreated = TRUE;
		if(NULL != RGB_ERASE_COLOR_PTR)
			rgbEraseColor = *RGB_ERASE_COLOR_PTR;
		si32Err = DSpSetBlankingColor(&rgbEraseColor);
	}
	/*DSpContext ɑΉ GDHandle 𓾂*/
	if(noErr == si32Err)
		si32Err = DSpContext_GetDisplayID(screenState->context,
										  &displayID);
	if(noErr == si32Err)
		si32Err = DMGetGDeviceByDisplayID(displayID,
										  &hGDevice,
										  FALSE);
	/*DSpContext ̃U[u
	  itXN[̕yэݒ肵AXN[蓮ŃZ^Oj*/
	if(noErr == si32Err)
		si32Err = DSpContext_GetAttributes(screenState->context,
										   &foundAttributes);
	if(noErr == si32Err)
	{
		contextAttributes.displayWidth   = foundAttributes.displayWidth;
		contextAttributes.displayHeight  = foundAttributes.displayHeight;
		contextAttributes.pageCount	     = 1;
		contextAttributes.contextOptions = 0;
		si32Err = DSpContext_Reserve(screenState->context,
									 &contextAttributes);
	}
	/*fXNgbvʂtF[hAEg*/
	if(noErr == si32Err)
		si32Err = DSpContext_FadeGammaOut(kDSpEveryContext,
										  NULL);
	/*ʂtXN[ɂ*/
	if(noErr == si32Err)
	{
		bFadeOut    = TRUE;
		si32Err = DSpContext_SetState(screenState->context,
									  kDSpContextState_Active);
	}
 	/*tXN[ʂ̏*/
	if(noErr == si32Err)
	{
		bIsActive   = TRUE;
		/*J[\\iKvȏꍇ̂݁j*/
		if(0 == (dspFullScreenHideCursor & enmFlags))
			ShowCursor();
		else
			HideCursor();
		/*DSpContext ̌_i Mac OS X ̂݁j*/
		if(FALSE != bIsOSX)
		{
			CGrafPtr								grafFront;
			PixMapHandle							hPix;
			Rect									rcPixBounds;
			SInt32									si32DeltaV;
			SInt32									si32DeltaH;
			Rect									rcPortBounds;

			/*DSpContext ̃tgobt@𓾂*/
			si32Err = DSpContext_GetFrontBuffer(screenState->context,
												&grafFront);
			/*tgobt@̌_*/
			if(noErr == si32Err)
			{
				hPix      = GetPortPixMap(grafFront);
				GetPortBounds(grafFront,
							  &rcPortBounds);
				GetPixBounds(hPix,
							 &rcPixBounds);
				si32DeltaV = (rcPortBounds.bottom - rcPortBounds.top) - (rcPixBounds.bottom - rcPixBounds.top) +
							 (rcPortBounds.bottom - rcPortBounds.top  - (SInt32)(ui32Height)) / 2;
				si32DeltaH = -(rcPortBounds.right - rcPortBounds.left - (SInt32)(ui32Width))  / 2;
				if((0 != si32DeltaV) || 
				   (0 != si32DeltaH))
				{
					GetGWorld(&gwGrafSave,
							  &hGDSave);
					SetGWorld(grafFront,
							  hGDevice);
					SetOrigin((SInt16)(si32DeltaH),
							  (SInt16)(si32DeltaV));
					SetGWorld(gwGrafSave,
							  hGDSave);
				}
			}
		}
	}
	/*tXN[pEBhE̍쐬*/
	if(noErr == si32Err)
	{
		/*ʒɂ悤ȋ`̈̍쐬*/
		rcWin.top     = (SInt16)((**hGDevice).gdRect.top + 
								 ((**hGDevice).gdRect.bottom - (**hGDevice).gdRect.top) / 2);
		rcWin.top    -= (SInt16)(ui32Height / 2);
		rcWin.left    = (SInt16)((**hGDevice).gdRect.left + 
								 ((**hGDevice).gdRect.right - (**hGDevice).gdRect.left) / 2);
		rcWin.left   -= (SInt16)(ui32Width / 2);
		rcWin.right   = (SInt16)(rcWin.left + ui32Width);
		rcWin.bottom  = (SInt16)(rcWin.top  + ui32Height);
		/*DSpContext ̏i Mac OS X ̂݁j*/
		if(FALSE != bIsOSX)
		{
			/*fBXvC̐ Mac OS X ɖ߂*/
			si32Err = DSpContext_SetState(screenState->context,
										  kDSpContextState_Paused);
			/*j[o[B*/
			HideMenuBar();
		}
		/*tXN[EBhE̍쐬*/
		screenState->screen = NewCWindow(NULL,
										 &rcWin,
										 "\p",
										 0,
										 plainDBox,
										 kFirstWindowOfClass,
										 0,
										 0);
		if(NULL == screenState->screen)
			si32Err = mFulErr;
		/*EBhE DSpContext ̔wiFœhԂ*/
		if(noErr == si32Err)
		{
			CGrafPtr		grafWin = GetWindowPort(screenState->screen);

			GetGWorld(&gwGrafSave,
					  &hGDSave);
			SetPortWindowPort(screenState->screen);
			GetForeColor(&rgbSave);
			RGBForeColor(&rgbEraseColor);
			GetWindowPortBounds(screenState->screen,
								&rcPaint);
			PaintRect(&rcPaint);
			RGBForeColor(&rgbSave);
			SetGWorld(gwGrafSave,
					  hGDSave);
			if(FALSE != QDIsPortBuffered(grafWin))
				QDFlushPortBuffer(grafWin,
								  NULL);
		}
		/*tXN[ʂփtF[hC*/
		if(noErr == si32Err)
		{
			if(FALSE != bIsOSX)
				bIsPaused = TRUE;
			si32Err = DSpContext_FadeGammaIn(kDSpEveryContext,
											 NULL);
		}
	}

	if(noErr == si32Err)
	{
		/*߂lɒlݒ*/
		*screenStatePtr = screenState;
		*wFullScreenPtr = screenState->screen;
	}
	else
	{
		/*G[*/
		OSStatus									si32Error;

		/*߂lɒlݒ*/
		*screenStatePtr = NULL;
		*wFullScreenPtr = NULL;
		/*tXN[EBhE쐬Ăꍇ͔j*/
		if(NULL != screenState->screen)
			DisposeWindow(screenState->screen);
		/*fBXvC̐AvP[VɕԂ*/
		if(FALSE != bIsPaused)
			si32Error = DSpContext_SetState(screenState->context,
											kDSpContextState_Active);
		/*ʂfXNgbvɖ߂*/
		if(FALSE != bIsActive)
			si32Error = DSpContext_SetState(screenState->context,
											kDSpContextState_Inactive);
		/*fXNgbvʂփtF[hC*/
		if(FALSE != bFadeOut)
			si32Error = DSpContext_FadeGammaIn(kDSpEveryContext,
											   NULL);
		/*j[o[̕\i Mac OS X ̂݁j*/
		if(FALSE != bIsOSX)
		{
			if(FALSE == IsMenuBarVisible())
			{
				ShowMenuBar();
				DrawMenuBar();
			}
		}
		/*DSpContext ̉*/
		if(FALSE != bIsCreated)
			si32Error = DSpContext_Release(screenState->context);
		/*tXN[Ԋi[̈*/
		CFAllocatorDeallocate(kCFAllocatorDefault,
							  screenState);
	}
	return si32Err;
}

/*
	      ֐ : DSpEndFullScreen
	        @\ : tXN[I
	         : restoreStatePtr          XN[Ԃւ̎Q
				                        o    k|C^ifXNgbvʂɖ߂ꍇj
				   enmFlags                 tXN[tO
				       0                       c J[\\
				       dspFullScreenHideCursor c J[\B
	      ߂l :    noErr : I
				   paramErr : restoreStatePtr Ƀk|C^nA
				              ͖ȃXN[ւ̎QƂn
				   ̑   : G[
	        l : 1. restoreStatePtr ɂ́ADSpBeginFullScreen ֐ screenStatePtr ɕԂꂽl
				      ̂܂ܓn
				   2. fXNgbvʂɖ߂Aj[o[͎Iɕ\
				   3. ߂l noErr, paramErr ȊȌꍇArestoreStatePtr ɕԂl𒲂ׂ
				      fXNgbvʂɖ߂̂tXN[ʂ̂܂܂Ȃ̂肷邱				             
				      ifXNgbvʂɖ߂ꍇ̂݃k|C^Ԃj
*/
OSStatus										DSpEndFullScreen(FullScreenStatusRef*	restoreStatePtr,
																 DSpFullScreenFlag		enmFlags)
{
	/*ϐ錾*/
	static Boolean									bIsOSX      = FALSE;
	static Boolean									bIsClassic  = FALSE;
	OSStatus										si32Err     = noErr;
	FullScreenStatusRef								screenState = NULL;
	Boolean											bFadeOut    = FALSE;
	Boolean											bIsValid    = FALSE;
	Boolean											bActive     = FALSE;
	Boolean											bInactive   = FALSE;
	Boolean											bFadeIn     = FALSE;
	Boolean											bRelease    = FALSE;

	/*p[^*/
	if(NULL == restoreStatePtr)
		return paramErr;
	if(NULL == (*restoreStatePtr)->screen)
		return paramErr;
	if(NULL == (*restoreStatePtr)->context)
		return paramErr;

	/**/
	/*sî݁j*/
	if((FALSE == bIsOSX) && 
	   (FALSE == bIsClassic))
	{
		bIsOSX     = RunningMacOSX();
		bIsClassic = (Boolean)(bIsOSX ? RunningClassic() : TRUE);
		bIsOSX     = (Boolean)(bIsOSX ? !bIsClassic      : FALSE);
	}
	/*tXN[*/
	screenState = *restoreStatePtr;
	/*tXN[ʂtF[hAEg*/
	if(noErr == si32Err)
		si32Err = DSpContext_FadeGammaOut(kDSpEveryContext,
										  NULL);
	/*tXN[EBhEւ̎QƂLł邩*/
	if(noErr == si32Err)
	{
		bFadeOut = TRUE;
		bIsValid = IsValidWindowRef(screenState->screen);
		if(FALSE == bIsValid)
			si32Err = errInvalidWindowRef;
	}
	if(noErr == si32Err)
	{
		/*tXN[EBhEj*/
		DisposeWindow(screenState->screen);
		screenState->screen = NULL;
		/*fBXvC̐AvP[Vɖ߂i Mac OS X ̂ j*/
		if(FALSE != bIsOSX)
			si32Err = DSpContext_SetState(screenState->context,
										  kDSpContextState_Active);
	}
	/*ʂfXNgbvɖ߂*/
	if(noErr == si32Err)
	{
		bActive = TRUE;
		si32Err = DSpContext_SetState(screenState->context,
									  kDSpContextState_Inactive);
	}
	/*fXNgbvփtF[hC*/
	if(noErr == si32Err)
	{
		bInactive = TRUE;
		si32Err = DSpContext_FadeGammaIn(kDSpEveryContext,
										 NULL);
	}
	if(noErr == si32Err)
	{
		bFadeIn = TRUE;
		/*J[\\iKvȏꍇ̂݁j*/
		if(0 == (dspFullScreenHideCursor & enmFlags))
			ShowCursor();
		else
			HideCursor();
		/*j[o[\iMac OS X ̂݁j*/
		if(FALSE != bIsOSX)
		{
			ShowMenuBar();
			DrawMenuBar();
		}
		/*DSpContext ̉*/
		si32Err = DSpContext_Release(screenState->context);
	}
	/*tXN[Ԋi[̈*/
	if(noErr == si32Err)
	{
		bRelease = TRUE;
		screenState->context = NULL;
		CFAllocatorDeallocate(kCFAllocatorDefault,
							  screenState);
		*restoreStatePtr = NULL;
	}
	else
	{
		/*G[*/
		/*tXN[EBhẼtF[hAEgɎsꍇAȂ*/
		if(FALSE != bFadeOut)
		{
			OSStatus					si32Error;

			if(FALSE == bIsValid)
				/*ȃtXN[EBhEւ̎QƂnꂽꍇAtF[hCČɖ߂*/
				si32Error = DSpContext_FadeGammaIn(kDSpEveryContext,
												   NULL);
			else
			{
				/*tXN[EBhEtF[hAEgAtXN[EBhEjꍇA
				  fXNgbv֋Iɖ߂*/
				/*fBXvC̐AvP[VɕԂ*/
				if(FALSE == bActive)
					si32Error = DSpContext_SetState(screenState->context,
													kDSpContextState_Active);
				/*ʂfXNgbvɖ߂*/
				if(FALSE == bInactive)
					si32Error = DSpContext_SetState(screenState->context,
													kDSpContextState_Inactive);
				/*fXNgbvփtF[hC*/
				if(FALSE == bFadeIn)
					si32Error = DSpContext_FadeGammaIn(kDSpEveryContext,
													   NULL);
				/*J[\\iKvȏꍇ̂݁j*/
				if(0 == (dspFullScreenHideCursor & enmFlags))
					ShowCursor();
				else
					HideCursor();
				/*j[o[̕\i Mac OS X ̂݁j*/
				if(FALSE != bIsOSX)
				{
					ShowMenuBar();
					DrawMenuBar();
				}
				/*DSpContext ̉*/
				if(FALSE == bRelease)
					si32Error = DSpContext_Release(screenState->context);
				/*tXN[Ԋi[̈*/
				screenState->context = NULL;
				CFAllocatorDeallocate(kCFAllocatorDefault,
									  screenState);
				*restoreStatePtr = NULL;
			}
		}
	}
	return si32Err;
}