/*
	t@C : Framework.c
	e         : t[[N[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : PEF oCii CFM x[XjAvP[V
	l         : 1. Mach-O oCiAvP[Vł͕sv
				   2. Mac OS 9.x ̏ꍇACFM oCĩt[[N̂݃[h\
*/
#include "Framework.h"

/*
	      ֐ : LoadFramework
	        @\ : wfBNg̃t[[N[hB
	         : FS_PARENT_DIR_PTR      t[[Ni[ĂfBNgւ̎Q
				   strFrameworkName       t[[N
				   bundlePtr          o    t[[Nւ̎Q
	      ߂l : noErr    c I
				   paramErr c bundlePtr Ƀk|C^n
				   ̑   c G[
	        l : 1. ߂l noErr ȊȌꍇAbundlePtr wl NULL Ԃ
				   2. t[[NgṕAUnloadFramework ֐ŉ邱
*/
OSStatus										LoadFramework(const FSRef*	FS_PARENT_DIR_PTR,
															  CFStringRef	strFrameworkName,
															  CFBundleRef*	bundlePtr)
{
	/*ϐ錾*/
	OSStatus					si32Err      = noErr;
	CFURLRef					urlParentDir = NULL;
	CFURLRef					urlBundle    = NULL;
	Boolean						bRet;

	/*p[^*/
	if(NULL == bundlePtr)
		return paramErr;

	/**/
	/*o̓p[^̏*/
	*bundlePtr = NULL;
	/*t[[Ni[fBNgւ̐΃pX𓾂*/
	if(noErr == si32Err)
	{
		urlParentDir = CFURLCreateFromFSRef(kCFAllocatorDefault,
											FS_PARENT_DIR_PTR);
		if(NULL == urlParentDir)
			si32Err = coreFoundationUnknownErr;
	}
	/*t[[Nւ̐΃pX𓾂*/
	if(noErr == si32Err)
	{
		urlBundle = CFURLCreateCopyAppendingPathComponent(kCFAllocatorDefault,
														  urlParentDir,
														  strFrameworkName,
														  FALSE);
		if(NULL == urlBundle)
			si32Err = coreFoundationUnknownErr;
	}

	/*t[[Nւ̎QƂVK쐬*/
	if(noErr == si32Err)
	{
		*bundlePtr = CFBundleCreate(kCFAllocatorDefault,
									urlBundle);
		if(NULL == *bundlePtr)
			si32Err = coreFoundationUnknownErr;
	}
	/*t[[N̎s\R[h[h*/
	if(noErr == si32Err)
	{
		bRet = CFBundleLoadExecutable(*bundlePtr);
	    if(!bRet)
			si32Err = coreFoundationUnknownErr;
	}

	/*㏈*/
	if((noErr != si32Err) && 
	   (NULL  != *bundlePtr))
	{
		CFRelease(*bundlePtr);
		*bundlePtr = NULL;
	}
	if(NULL != urlBundle)
		CFRelease(urlBundle);
	if(NULL != urlParentDir)
		CFRelease(urlParentDir);

	return si32Err;
}

/*
	      ֐ : LoadSystemFramework
	        @\ : /System/Library/Frameworks ̃t[[N[hB
	         : strFrameworkName      t[[N
				   bundlePtr         o    t[[Nւ̎Q
	      ߂l : noErr    c I
				   paramErr c bundlePtr Ƀk|C^n
				   ̑   c G[
	        l : 1. ߂l noErr ȊȌꍇAbundlePtr wl NULL Ԃ
				   2. t[[NgṕAUnloadFramework ֐ŉ邱
*/
OSStatus										LoadSystemFramework(CFStringRef		strFrameworkName,
																	CFBundleRef*	bundlePtr)
{
	/*ϐ錾*/
	OSStatus					si32Err = noErr;
	FSRef						fsFrameworksDir;

	/*p[^*/
	if(NULL == bundlePtr)
		return paramErr;

	/**/
	/*o̓p[^̏*/
	*bundlePtr = NULL;
	/*Frameworks VXefBNǧ*/
	if(noErr == si32Err)
		si32Err = FSFindFolder(kOnAppropriateDisk,
							   kFrameworksFolderType,
							   TRUE,
							   &fsFrameworksDir);
	/*t[[N[h*/
	if(noErr == si32Err)
		si32Err = LoadFramework(&fsFrameworksDir,
								strFrameworkName,
								bundlePtr);

	return si32Err;
}

/*
	      ֐ : UnloadFramework
	        @\ : t[[NA[hB
	         : bundlePtr      t[[Nւ̎Q
				              o    k|C^
	      ߂l : 
	        l : 
*/
void											UnloadFramework(CFBundleRef*	bundlePtr)
{
	/*p[^*/
	if(NULL == bundlePtr)
		return;
	if(NULL == *bundlePtr)
		return;

	/**/
	CFBundleUnloadExecutable(*bundlePtr);
	CFRelease(*bundlePtr);
	*bundlePtr = NULL;
}
