/*
	t@C : GSpLibrary.c
	e         : Carbon GameSprockets Cu[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : Mac OS X 10.0 ȍ~
	l         : 
*/
#include "GSpLibrary.h"
#include "VersionUtilities.h"
#include "Framework.h"
#include "SharedLibrary.h"

/*^`*/
/*CuQƌ^*/
union _Library
{
	CFBundleRef										frameworkRef;	/*Mac OS X   : t[[Nւ̎Q*/
	CFragConnectionID								connectionID;	/*Mac OS 9.x : LCuւ̎Q*/
};
typedef union _Library							_Library;

/*Cu֐|C^*/
typedef OSStatus								(*LoadGSpLibraryProcPtr)(CFStringRef,
																		 LibraryRef*);
typedef ProcPtr									(*GetGSpAPIAddressProcPtr)(LibraryRef,
																		   CFStringRef);
typedef void									(*UnloadGSpLibraryProcPtr)(LibraryRef*);


/*֐vg^Cv*/
/*Mac OS X pCu샋[`*/
static OSStatus									LoadGSpLibrary_X(CFStringRef,
																 LibraryRef*);
static ProcPtr									GetGSpAPIAddress_X(LibraryRef,
																   CFStringRef);
static void										UnloadGSpLibrary_X(LibraryRef*);

/*Mac OS 9.x pCu샋[`*/
static OSStatus									LoadGSpLibrary_Classic(CFStringRef,
																	   LibraryRef*);
static ProcPtr									GetGSpAPIAddress_Classic(LibraryRef,
																		 CFStringRef);
static void										UnloadGSpLibrary_Classic(LibraryRef*);


#pragma mark -- GameSprockets libraries operation --
/*
	      ֐ : LoadGSpLibrary
	        @\ : GameSprockets Cu[h
	         : strLibName      GameSprockets Cu
				   connIDPtr   o    GameSprockets Cuւ̎Q
	      ߂l : noErr    : I
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. GameSprockets CǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKwi Mac OS 9.x j
				          E@\gtH_          i Mac OS 9.x j
				          E/System/Library/Frameworks/ tH_i Mac OS X j
				   2. gp UnloadGSpLibrary ֐ GameSprockets CuA[h邱
					  i[Nj
*/
OSStatus										LoadGSpLibrary(CFStringRef	strLibName,
															   LibraryRef*	libPtr)
{
	/*ϐ錾*/
	static LoadGSpLibraryProcPtr					ipiLoadGSpLibrary[2] = {&LoadGSpLibrary_Classic,
																			&LoadGSpLibrary_X};

	/**/
	return (*(ipiLoadGSpLibrary[RuntimeHash()]))(strLibName,
												 libPtr);
}

/*
	      ֐ : GetGSpAPIAddress
	        @\ : GameSprockets w API ֐ւ̊֐|C^𓾂
	         : libRef           GameSprockets Cuւ̎Q
				   strProcName      API ֐
	      ߂l : w API ֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL |C^Ԃ
*/
ProcPtr											GetGSpAPIAddress(LibraryRef		libRef,
																 CFStringRef	strProcName)
{
	/*ϐ錾*/
	static GetGSpAPIAddressProcPtr					ipiGetGSpAPIAddress[2] = {&GetGSpAPIAddress_Classic,
																			  &GetGSpAPIAddress_X};

	/**/
	return (*(ipiGetGSpAPIAddress[RuntimeHash()]))(libRef,
												   strProcName);
}

/*
	      ֐ : UnloadGSpLibrary
	        @\ : GameSprockets CuA[h
	         : libPtr      GameSprockets Cuւ̎Q
				           o    ȃCuւ̎Q
	      ߂l : 
	        l : 
*/
void											UnloadGSpLibrary(LibraryRef*	libPtr)
{
	/*ϐ錾*/
	static UnloadGSpLibraryProcPtr					ipiUnloadGSpLibrary[2] = {&UnloadGSpLibrary_Classic,
																			  &UnloadGSpLibrary_X};

	/**/
	(*(ipiUnloadGSpLibrary[RuntimeHash()]))(libPtr);
}

#pragma mark -- Internal Programing Interface --
/*GameSprockets for Mac OS X ( CFM ) IPI*/
/*
	      ֐ : LoadGSpLibrary_X
	        @\ : GameSprockets t[[N[h
	         : strLibName      GameSprockets t[[N
				   libPtr      o    GameSprockets t[[N̎QƂւ̃|C^
	      ߂l : noErr    : I
				   paramErr : strLibName, libPtr Ƀk|C^n
				   ̑   : G[
	        l : 1. /System/Library/Frameworks/ fBNgɑ݂t[[N݂̂[h̑ΏۂƂȂ
*/
OSStatus										LoadGSpLibrary_X(CFStringRef	strLibName,
																 LibraryRef*	libPtr)
{
	/*ϐ錾*/
	OSStatus										si32Err;
	LibraryRef										libRef;

	/*p[^*/
	if(NULL == strLibName)
		return paramErr;
	if(NULL == libPtr)
		return paramErr;

	/**/
	libRef = (LibraryRef)(CFAllocatorAllocate(kCFAllocatorDefault,
											  (CFIndex)(sizeof(_Library)),
											  0));
	if(NULL == libRef)
	{
		*libPtr = NULL;
		return coreFoundationUnknownErr;
	}
	si32Err = LoadSystemFramework(strLibName,
								  &(libRef->frameworkRef));
	if(noErr == si32Err)
		*libPtr = libRef;
	else
	{
		libRef->frameworkRef = NULL;
		CFAllocatorDeallocate(kCFAllocatorDefault,
							  libRef);
		*libPtr = NULL;
	}
	return si32Err;
}

/*
	      ֐ : GetGSpAPIAddress_X
	        @\ : GameSprockets w API ֐ւ̊֐|C^𓾂
	         : libRef           GameSprockets t[[Nւ̎Q
				   strProcName      API ֐
	      ߂l : w API ֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL Ԃ
*/
ProcPtr											GetGSpAPIAddress_X(LibraryRef	libRef,
																   CFStringRef	strAPIName)
{
	/**/
	return (ProcPtr)(GetFrameworkProcedureAddress(libRef->frameworkRef,
												  strAPIName));
}

/*
	      ֐ : UnloadGSpLibrary_X
	        @\ : GameSprockets t[[NA[h
	         : libPtr      GameSprockets t[[N̎QƂւ̃|C^
				           o    ȃt[[Nւ̎Q
	      ߂l : 
	        l : 
*/
void											UnloadGSpLibrary_X(LibraryRef*	libPtr)
{
	/*ϐ錾*/
	LibraryRef										libRef;

	/*p[^*/
	if(NULL == libPtr)
		return;

	/**/
	libRef = *libPtr;
	UnloadFramework(&(libRef->frameworkRef));
	libRef->frameworkRef = NULL;
	CFAllocatorDeallocate(kCFAllocatorDefault,
						  libRef);
	*libPtr = NULL;
}

/*GameSprockets for Mac OS 9.x IPI*/
/*
	      ֐ : LoadGSpLibrary_Classic
	        @\ : GameSprockets LCu[h
	         : strLibName      GameSprockets LCu
				   libPtr      o    GameSprockets LCu̎QƂւ̃|C^
	      ߂l : noErr    : I
				   paramErr : strLibName, libPtr Ƀk|C^n
				   ̑   : G[
	        l : 
*/
OSStatus										LoadGSpLibrary_Classic(CFStringRef	strLibName,
																	   LibraryRef*	libPtr)
{
	/*ϐ錾*/
	OSStatus										si32Err;
	LibraryRef										libRef;

	/*p[^*/
	if(NULL == strLibName)
		return paramErr;
	if(NULL == libPtr)
		return paramErr;

	/**/
	libRef = (LibraryRef)(CFAllocatorAllocate(kCFAllocatorDefault,
											  (CFIndex)(sizeof(_Library)),
											  0));
	if(NULL == libRef)
	{
		*libPtr = NULL;
		return coreFoundationUnknownErr;
	}
	si32Err = LoadSystemSharedLibrary(strLibName,
									  &(libRef->connectionID));
	if(noErr == si32Err)
		*libPtr = libRef;
	else
	{
		libRef->connectionID = NULL;
		CFAllocatorDeallocate(kCFAllocatorDefault,
							  libRef);
		*libPtr = NULL;
	}
	return si32Err;
}

/*
	      ֐ : GetGSpAPIAddress_Classic
	        @\ : GameSprockets w API ֐ւ̊֐|C^𓾂
	         : libRef           LCuւ̎Q
				   strProcName      API ֐
	      ߂l : w API ֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL Ԃ
*/
ProcPtr											GetGSpAPIAddress_Classic(LibraryRef		libRef,
																		 CFStringRef	strAPIName)
{
	/**/
	return (ProcPtr)(GetSharedLibraryProcedureAddress(libRef->connectionID,
													  strAPIName));
}

/*
	      ֐ : UnloadGSpLibrary_Classic
	        @\ : GameSprockets LCuA[h
	         : libPtr      GameSprockets LCu̎QƂւ̃|C^
				           o    ȋLCuւ̎Q
	      ߂l : 
	        l : 
*/
void											UnloadGSpLibrary_Classic(LibraryRef*	libPtr)
{
	/*ϐ錾*/
	LibraryRef										libRef;

	/*p[^*/
	if(NULL == libPtr)
		return;

	/**/
	libRef = *libPtr;
	UnloadSharedLibrary(&(libRef->connectionID));
	libRef->connectionID = NULL;
	CFAllocatorDeallocate(kCFAllocatorDefault,
						  libRef);
	*libPtr = NULL;
}