/*
	t@C : SharedLibrary.c
	e         : Carbon LCu[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : Mac OS X 10.0 ȍ~
	l         : 
*/
#include "SharedLibrary.h"

/*֐vg^Cv*/
static OSErr									GetSharedLib(const FSRef*,
															 CFStringRef,
															 CFragLoadOptions,
															 CFragConnectionID*);
static OSErr									GetSystemSharedLib(CFStringRef,
																   CFragLoadOptions,
																   CFragConnectionID*);


/*
	      ֐ : LoadSharedLibrary
	        @\ : LCu[h
	         : FS_PARENT_DIR_PTR      LCui[efBNgւ̎Q
				   strLibName             LCu
				   connIDPtr          o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : FS_PARENT_DIR_PTR, strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											LoadSharedLibrary(const FSRef*			FS_PARENT_DIR_PTR,
																  CFStringRef			strLibName,
																  CFragConnectionID*	connIDPtr)
{
	return GetSharedLib(FS_PARENT_DIR_PTR,
						strLibName,
						kReferenceCFrag,
						connIDPtr);
}

/*
	      ֐ : LoadSystemSharedLibrary
	        @\ : LCu[h
	         : strLibName      LCu
				   connIDPtr   o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. LCǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKw
				          E@\gtH_i Mac OS 9.x ̂݁j
				   2. gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											LoadSystemSharedLibrary(CFStringRef			strLibName,
																		CFragConnectionID*	connIDPtr)
{
	return GetSystemSharedLib(strLibName,
							  kReferenceCFrag,
							  connIDPtr);
}

/*
	      ֐ : FindSharedLibrary
	        @\ : [hϋLCu
	         : FS_PARENT_DIR_PTR      LCui[efBNgւ̎Q
				   strLibName             LCu
				   connIDPtr          o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : FS_PARENT_DIR_PTR, strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. AvP[VIAIɋLCuA[h邽߁A
				      UnloadSharedLibrary ֐ŋLCuKv͂Ȃ
				      i UnloadSharedLibrary ֐ŉꍇ͖̓`j
*/
OSErr											FindSharedLibrary(const FSRef*			FS_PARENT_DIR_PTR,
																  CFStringRef			strLibName,
																  CFragConnectionID*	connIDPtr)
{
	return GetSharedLib(FS_PARENT_DIR_PTR,
						strLibName,
						kFindCFrag,
						connIDPtr);
}

/*
	      ֐ : FindSystemSharedLibrary
	        @\ : LCu[h
	         : strLibName      LCu
				   connIDPtr   o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. LCǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKw
				          E@\gtH_i Mac OS 9.x ̂݁j
				   2. AvP[VIAIɋLCuA[h邽߁A
				      UnloadSharedLibrary ֐ŋLCuKv͂Ȃ
				      i UnloadSharedLibrary ֐ŉꍇ͖̓`j
*/
OSErr											FindSystemSharedLibrary(CFStringRef			strLibName,
																		CFragConnectionID*	connIDPtr)
{
	return GetSystemSharedLib(strLibName,
							  kFindCFrag,
							  connIDPtr);
}

/*
	      ֐ : GetSharedLibraryProcedureAddress
	        @\ : LCu̎w֐ւ̊֐|C^𓾂
	         : libRef           LCuւ̎Q
				   strProcName      ֐
	      ߂l : w֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL |C^Ԃ
*/
ProcPtr											GetSharedLibraryProcedureAddress(CFragConnectionID	connID,
																				 CFStringRef		strProcName)
{
	/*ϐ錾*/
	OSErr											si16Err      = noErr;
	Boolean											bRet         = TRUE;
	ConstStringPtr									pstrProcName;
	Str255											pstrBounds;
	CFragSymbolClass								symbolClass;
	ProcPtr											fpRet        = NULL;

	/**/
	/*LCû Pascal ɕϊ*/
	pstrProcName = CFStringGetPascalStringPtr(strProcName,
											  CFStringGetSystemEncoding());
	if(NULL == pstrProcName)
	{
		pstrProcName = pstrBounds;
		bRet = CFStringGetPascalString(strProcName,
									   pstrBounds,
									   (CFIndex)(sizeof(pstrBounds)),
									   CFStringGetSystemEncoding());
	}
	/*LCu̎w֐ւ̊֐|C^𓾂*/
	if(FALSE != bRet)
	{
	    si16Err = FindSymbol(connID,
							 pstrProcName, 
							 (Ptr*)(&fpRet),
							 &symbolClass);
		if(noErr != si16Err)
			fpRet = NULL;
	}
	return fpRet;
}

/*
	      ֐ : UnloadSharedLibrary
	        @\ : LCuA[h
	         : connIDPtr      LCuւ̎Q
				              o    k|C^
	      ߂l : 
	        l : 
*/
void											UnloadSharedLibrary(CFragConnectionID*	connIDPtr)
{
	/*ϐ錾*/
	OSErr											si16Err;

	/*p[^*/
	if(NULL == connIDPtr)
		return;

	/**/
	si16Err = CloseConnection(connIDPtr);
	*connIDPtr = NULL;
}

#pragma mark -- Internal Programing Interface --
/* Internal Programing Interface */
/*
	      ֐ : GetSharedLib
	        @\ : LCuւ̎QƂ𓾂
	         : FS_PARENT_DIR_PTR      LCui[fBNgւ̎Q
				   strLibName             LCu
				   connIDPtr          o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1.  ui32Options ̒l kReferenceCFrag ̏ꍇA
				      gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											GetSharedLib(const FSRef*		FS_PARENT_DIR_PTR,
															 CFStringRef		strLibName,
															 CFragLoadOptions	ui32Options,
															 CFragConnectionID*	connIDPtr)
{
	/*ϐ錾*/
	OSErr											si16Err       = noErr;
	CFURLRef										urlParentDir  = NULL;
	CFURLRef										urlLib        = NULL;
	Boolean											bRet          = TRUE;
	FSRef											fsLib;
	FSSpec											fssLib;
	FSCatalogInfo									fsciLibInfo;
	ConstStringPtr									pstrLibName;
	Str63											pstrBounds;
	Str255											pstrErrString;
	Ptr												mainAddr;

	/*p[^*/
	if(NULL == FS_PARENT_DIR_PTR)
		return paramErr;
	if(NULL == strLibName)
		return paramErr;
	if(NULL == connIDPtr)
		return paramErr;

	/**/
	/*LCui[fBNgւ̐΃pX𓾂*/
	if(noErr == si16Err)
	{
		urlParentDir = CFURLCreateFromFSRef(kCFAllocatorDefault,
											FS_PARENT_DIR_PTR);
		if(NULL == urlParentDir)
			si16Err = coreFoundationUnknownErr;
	}
	/*LCuւ̐΃pX𓾂*/
	if(noErr == si16Err)
	{
		urlLib = CFURLCreateCopyAppendingPathComponent(kCFAllocatorDefault,
													   urlParentDir,
													   strLibName,
													   FALSE);
		if(NULL == urlLib)
			si16Err = coreFoundationUnknownErr;
	}
	/*LCuւ FSRef 𓾂*/
	if(noErr == si16Err)
	{
		bRet = CFURLGetFSRef(urlLib,
							 &fsLib);
		if(FALSE == bRet)
			si16Err = coreFoundationUnknownErr;
	}
	/*Core Foundation IuWFNg̉*/
	if(NULL != urlParentDir)
		CFRelease(urlParentDir);
	if(NULL != urlLib)
		CFRelease(urlLib);
	/*LCuւ FSSpec 𓾂*/
	if(noErr == si16Err)
	{
		fsciLibInfo.dataLogicalSize  = 0;
		fsciLibInfo.dataPhysicalSize = 0;
		si16Err = FSGetCatalogInfo(&fsLib,
								   kFSCatInfoDataSizes,
								   &fsciLibInfo,
								   NULL,
								   &fssLib,
								   NULL);
	}
	/*LCû Pascal ɕϊ*/
	if(noErr == si16Err)
	{
		pstrLibName = CFStringGetPascalStringPtr(strLibName,
												 CFStringGetSystemEncoding());
		if(NULL == pstrLibName)
		{
			pstrLibName = pstrBounds;
			bRet = CFStringGetPascalString(strLibName,
										   pstrBounds,
										   (CFIndex)(sizeof(pstrBounds)),
										   CFStringGetSystemEncoding());
			if(FALSE == bRet)
				si16Err = coreFoundationUnknownErr;
		}
	}
	/*LCuւ̎QƂ𓾂*/
	if(noErr == si16Err)
	    si16Err = GetDiskFragment(&fssLib,
								  0,
								  (UInt32)(fsciLibInfo.dataLogicalSize),
								  pstrLibName,
								  ui32Options,
								  connIDPtr,
								  &mainAddr,
								  pstrErrString);
	if(noErr != si16Err)
		*connIDPtr = NULL;
	return si16Err;
}

/*
	      ֐ : GetSystemSharedLib
	        @\ : LCuւ̎QƂ𓾂
	         : strLibName      LCu
				   connIDPtr   o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. [h鋤LCúAȉ̏ꏊɂȂ΂ȂȂ
				          EAvP[VƓKw
				          E@\gtH_i Mac OS 9.x ̂݁j
				   2.  ui32Options ̒l kReferenceCFrag ̏ꍇA
				      gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											GetSystemSharedLib(CFStringRef			strLibName,
																   CFragLoadOptions		ui32Options,
																   CFragConnectionID*	connIDPtr)
{
	/*ϐ錾*/
	OSErr											si16Err       = noErr;
	Boolean											bRet          = TRUE;
	ConstStringPtr									pstrLibName;
	Str63											pstrBounds;
	Str255											pstrErrString;
	Ptr												mainAddr;

	/*p[^*/
	if(NULL == strLibName)
		return paramErr;
	if(NULL == connIDPtr)
		return paramErr;

	/**/
	/*LCû Pascal ɕϊ*/
	if(noErr == si16Err)
	{
		pstrLibName = CFStringGetPascalStringPtr(strLibName,
												 CFStringGetSystemEncoding());
		if(NULL == pstrLibName)
		{
			pstrLibName = pstrBounds;
			bRet = CFStringGetPascalString(strLibName,
										   pstrBounds,
										   (CFIndex)(sizeof(pstrBounds)),
										   CFStringGetSystemEncoding());
			if(FALSE == bRet)
				si16Err = coreFoundationUnknownErr;
		}
	}
	/*LCuւ̎QƂ𓾂*/
	if(noErr == si16Err)
	    si16Err = GetSharedLibrary(pstrLibName,
								   kPowerPCCFragArch,
								   ui32Options,
								   connIDPtr,
								   &mainAddr,
								   pstrErrString);
	if(noErr != si16Err)
		*connIDPtr = NULL;
	return si16Err;
}