/*
	t@C : UserPreference.h
	e         : [U[ʐݒt@CIuWFNgC^[tF[X
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.2 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. UserPreference ̔hNX 2 ȏ㐶łȂ悤ɂ邱
	               2. ev[g^Ɏgpł^ꗗ
	                  CFArrayRef
	                  CFBooleanRef
	                  CFDataRef
	                  CFDateRef
	                  CFDictionaryRef
	                  CFNumberRef
	                  CFStringRef
	                  StringPtr
	                  char*
	                  bool
	                  signed char
	                  short
	                  long
*/

#ifndef __USERPREFERENCE__
#define __USERPREFERENCE__

#ifndef _EXCEPTION
#include <exception>
#endif
#ifndef __CARBON__
#include <Carbon.h>
#endif


//[U[ʐݒt@CIuWFNgC^[tF[X
class UserPreference
{
	public :
		//RXgN^EfBXgN^
		virtual										~UserPreference(void);

		//o֐
		void										Remove(CFStringRef)	throw();

		//ANZbT
		template<class T>
		T											copyValue(CFStringRef);
		template<class T>
		void										getValue(CFStringRef,
															 T);
		template<class T>
		void										setValue(CFStringRef,
															 T)	throw();
		bool										exists(CFStringRef)	throw();

	protected :
		//RXgN^EfBXgN^
													UserPreference(void);

		//ANZbT
		virtual CFStringRef							getApplicationID(void)                   throw() = 0;
		void										setBoolean(CFStringRef,
															   bool)                         throw();
		void										setInteger(CFStringRef,
															   CFIndex)                      throw();
		void										setCFObject(CFStringRef,
																CFPropertyListRef)           throw();
		bool										getBooleanIfExists(CFStringRef,
																	   bool&)                throw();
		bool										getIntegerIfExists(CFStringRef,
																	   CFIndex&)             throw();
		bool										copyCFObjectIfExists(CFStringRef,
																		 CFPropertyListRef&) throw();

	private :
													UserPreference(const UserPreference&);	 ///
		UserPreference&								operator=(const UserPreference&);		 ///
};

//f[^o`
/*
	update_ : XVtO
*/

//C^[tF[Xdl
/*
	ANZXw : protected
	      ֐ : UserPreference::UserPreference
	        @\ : [U[ʐݒt@CIuWFNg̃RXgN^
	         : 
	      ߂l : 
	        O : 
	        l : 
*/

/*
	ANZXw : public
	      ֐ : UserPreference::~UserPreference
	        @\ : [U[ʐݒt@CIuWFNg̃fBXgN^
	         : 
	      ߂l : 
	        O : 
	        l : 1. ݒt@C̕ۑi CFPreferencesAppSynchronize API j
	                  hNXŋLq邱
*/

/*
	ANZXw : public
	      ֐ : UserPreference::Remove
	        @\ : wL[폜
	         : strKey      L[
	      ߂l : 
	        O : 
	        l : 
*/

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<T>
	        @\ : L[ɑΉl̕𓾂i ėp j
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFArray ł͂Ȃꍇ
	        l : 1. std::bad_exception ^̗O𓊂
*/
template<class T> 
inline 
T											UserPreference::copyValue(CFStringRef	strKey)
{
	//
	throw std::bad_exception();
	strKey;
	return T();
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFArrayRef>
	        @\ : L[ɑΉl̕𓾂i CFArray Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFArray ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFArrayRef									UserPreference::copyValue<CFArrayRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							aryValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  aryValue);
	if(bValid)
		bValid = (::CFArrayGetTypeID() == ::CFGetTypeID(aryValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFArrayRef>(aryValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFBooleanRef>
	        @\ : L[ɑΉl̕𓾂i CFBoolean Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFBoolean ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFBooleanRef								UserPreference::copyValue<CFBooleanRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							blnValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  blnValue);
	if(bValid)
		bValid = (::CFBooleanGetTypeID() == ::CFGetTypeID(blnValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFBooleanRef>(blnValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFDataRef>
	        @\ : L[ɑΉl̕𓾂i CFData Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFData ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFDataRef									UserPreference::copyValue<CFDataRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							datValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  datValue);
	if(bValid)
		bValid = (::CFDataGetTypeID() == ::CFGetTypeID(datValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFDataRef>(datValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFDateRef>
	        @\ : L[ɑΉl̕𓾂i CFDate Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFDate ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFDateRef									UserPreference::copyValue<CFDateRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							dtValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  dtValue);
	if(bValid)
		bValid = (::CFDateGetTypeID() == ::CFGetTypeID(dtValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFDateRef>(dtValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFDictionaryRef>
	        @\ : L[ɑΉl̕𓾂i CFDictionary Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFDictioonary ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFDictionaryRef								UserPreference::copyValue<CFDictionaryRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							dicValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  dicValue);
	if(bValid)
		bValid = (::CFDictionaryGetTypeID() == ::CFGetTypeID(dicValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFDictionaryRef>(dicValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFNumberRef>
	        @\ : L[ɑΉl̕𓾂i CFNumber Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFNumber ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFNumberRef									UserPreference::copyValue<CFNumberRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							nValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  nValue);
	if(bValid)
		bValid = (::CFNumberGetTypeID() == ::CFGetTypeID(nValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFNumberRef>(nValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<CFStringRef>
	        @\ : L[ɑΉl̕𓾂i CFString Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ CFString ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
CFStringRef									UserPreference::copyValue<CFStringRef>(CFStringRef	strKey)
{
	//ϐ錾
	CFPropertyListRef							strValue;
	bool										bValid;

	//
	bValid = copyCFObjectIfExists(strKey,
								  strValue);
	if(bValid)
		bValid = (::CFStringGetTypeID() == ::CFGetTypeID(strValue));
	if(!bValid)
		throw std::bad_exception();
	return static_cast<CFStringRef>(strValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<bool>
	        @\ : L[ɑΉl̕𓾂i bool Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ bool ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
bool										UserPreference::copyValue<bool>(CFStringRef	strKey)
{
	//ϐ錾
	bool										bValid;
	bool										bRet   = FALSE;

	//
	bValid = getBooleanIfExists(strKey,
								bRet);
	if(!bValid)
		throw std::bad_exception();
	return bRet;
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<signed char>
	        @\ : L[ɑΉl̕𓾂i signed char Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ signed char ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
signed char									UserPreference::copyValue<signed char>(CFStringRef	strKey)
{
	//ϐ錾
	bool										bValid;
	CFIndex										si32Value;

	//
	bValid = getIntegerIfExists(strKey,
								si32Value);
	if(!bValid)
		throw std::bad_exception();
	return static_cast<signed char>(si32Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<short>
	        @\ : L[ɑΉl̕𓾂i short Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ short ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
short										UserPreference::copyValue<short>(CFStringRef	strKey)
{
	//ϐ錾
	bool										bValid;
	CFIndex										si32Value;

	//
	bValid = getIntegerIfExists(strKey,
								si32Value);
	if(!bValid)
		throw std::bad_exception();
	return static_cast<short>(si32Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyValue<long>
	        @\ : L[ɑΉl̕𓾂i signed char Łj
	         : strKey      L[
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c ݒľ^ long ł͂Ȃꍇ
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
template<> 
inline 
long										UserPreference::copyValue<long>(CFStringRef	strKey)
{
	//ϐ錾
	bool										bValid;
	CFIndex										si32Value;

	//
	bValid = getIntegerIfExists(strKey,
								si32Value);
	if(!bValid)
		throw std::bad_exception();
	return static_cast<long>(si32Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::getValue<T>
	        @\ : L[ɑΉl𓾂i ėp j
	         : strKey            L[
	               anyBufferPtr  o    ݒli[pobt@
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c 펞
	        l : 1. std::bad_exception ^̗O𓊂
	        @     2. ev[g^ɂ̓|C^^n
*/
template<class T> 
inline 
void										UserPreference::getValue(CFStringRef	strKey,
																	 T				anyBufferPtr)
{
	//
	throw std::bad_exception();
	strKey;
	anyBufferPtr;
}

/*
	ANZXw : public
	      ֐ : UserPreference::getValue<char*>
	        @\ : L[ɑΉl𓾂i C  j
	         : strKey            L[
	               anyBufferPtr  o    ݒli[pobt@
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c 1. ݒľ^ CFString ł͂Ȃꍇ
	                                     2. CFString  C ɕϊłȂꍇ
	        l :  anyBufferPtr ɂ͏\ȗ̈pӂ邱
*/
template<> 
inline 
void										UserPreference::getValue<char*>(CFStringRef	strKey,
																			char*		cstrBufferPtr)
{
	//ϐ錾
	CFStringRef									strValue;
	CFIndex										si32Len;
	Boolean										blnRet;

	//
	strValue  = copyValue<CFStringRef>(strKey);
	si32Len   = ::CFStringGetLength(strValue);
	si32Len <<= 1;
	si32Len  += 1;
	blnRet    = ::CFStringGetCString(strValue,
									 cstrBufferPtr,
									 si32Len,
									 ::CFStringGetSystemEncoding());
	::CFRelease(strValue);
	if(FALSE == blnRet)
		throw std::bad_exception();
}

/*
	ANZXw : public
	      ֐ : UserPreference::getValue<StringPtr>
	        @\ : L[ɑΉl𓾂i Pascal  j
	         : strKey            L[
	               anyBufferPtr  o    ݒli[pobt@
	      ߂l : ݒlւ̎Q
	        O : std::bad_exception c 1. ݒľ^ CFString ł͂Ȃꍇ
	                                     2. CFString  Pascal ɕϊłȂꍇ
	        l :  pstrBufferPtr ɂ͏\ȗ̈iő 256 oCgjpӂ邱
*/
template<> 
inline 
void										UserPreference::getValue<StringPtr>(CFStringRef	strKey,
																				StringPtr	pstrBufferPtr)
{
	//ϐ錾
	CFStringRef									strValue;
	CFIndex										si32Len;
	Boolean										blnRet;

	//
	strValue = copyValue<CFStringRef>(strKey);
	si32Len   = ::CFStringGetLength(strValue);
	si32Len <<= 1;
	si32Len  += 1;
	if(si32Len > 256)
		si32Len = 256;
	blnRet   = ::CFStringGetPascalString(strValue,
										 pstrBufferPtr,
										 si32Len,
										 ::CFStringGetSystemEncoding());
	::CFRelease(strValue);
	if(FALSE == blnRet)
		throw std::bad_exception();
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<T>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi ėp j
	         : strKey        L[
	               anyValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1. Ȃ
*/
template<class T> 
inline 
void UserPreference::setValue(CFStringRef strKey, T anyValue) throw()
{
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFArrayRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFArray  j
	         : strKey        L[
	               aryValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFArrayRef>(CFStringRef	strKey,
																				 CFArrayRef		aryValue) throw()
{
	//
	setCFObject(strKey,
				aryValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFBooleanRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFBoolean  j
	         : strKey        L[
	               blnValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFBooleanRef>(CFStringRef	strKey,
																				   CFBooleanRef	blnValue) throw()
{
	//
	setCFObject(strKey,
				blnValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFDataRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFData  j
	         : strKey        L[
	               datValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFDataRef>(CFStringRef	strKey,
																				CFDataRef	datValue) throw()
{
	//
	setCFObject(strKey,
				datValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFDateRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFDate  j
	         : strKey       L[
	               dtValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFDateRef>(CFStringRef	strKey,
																				CFDateRef	dtValue) throw()
{
	//
	setCFObject(strKey,
				dtValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFDictioaryRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFDictionary  j
	         : strKey        L[
	               dicValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFDictionaryRef>(CFStringRef		strKey,
																					  CFDictionaryRef	dicValue) throw()
{
	//
	setCFObject(strKey,
				dicValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFNumberRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFNumber  j
	         : strKey      L[
	               nValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFNumberRef>(CFStringRef	strKey,
																				  CFNumberRef	nValue) throw()
{
	//
	setCFObject(strKey,
				nValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<CFStringRef>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi CFString  j
	         : strKey        L[
	               strValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<CFStringRef>(CFStringRef	strKey,
																				  CFStringRef	strValue) throw()
{
	//
	setCFObject(strKey,
				strValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::setValue<char*>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi C  j
	         : strKey        L[
	               strValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
/*
template<> 
inline void UserPreference::setValue<char*>(CFStringRef	strKey, char* cstrBufferPtr) throw()
{
	//
	setValue<const char*>(strKey, cstrBufferPtr);
}
*/
/*
	ANZXw : public
	      ֐ : UserPreference::setValue<const char*>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi C  j
	         : strKey        L[
	               strValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
/*
RpCʂȂ̂łƂ肠RgAEgAւ̃R[hĂ݂B
2003/01/03 : keta

template<> 
inline 
void UserPreference::setValue<const char*>(CFStringRef	strKey, const char* CSTR_BUFFER_PTR) throw()
{
	//ϐ錾
	CFStringRef	strValue;

	//
	strValue = ::CFStringCreateWithCString(kCFAllocatorDefault,
						CSTR_BUFFER_PTR,
						::CFStringGetSystemEncoding());
	setCFObject(strKey, strValue);
	if(NULL != strValue)
		::CFRelease(strValue);
}
*/

template<> 
inline void UserPreference::setValue<char*>(CFStringRef	strKey, char* cstrBufferPtr) throw()
{
	//ϐ錾
	CFStringRef	strValue;

	//
	strValue = ::CFStringCreateWithCString(kCFAllocatorDefault,
						cstrBufferPtr,
						::CFStringGetSystemEncoding());
	setCFObject(strKey, strValue);
	if(NULL != strValue)
		::CFRelease(strValue);
}



/*
	ANZXw : public
	      ֐ : UserPreference::setValue<StringPtr>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi Pascal  j
	         : strKey        L[
	               strValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
/*

RpCʂȂ̂łƂ肠ւ̃R[hB
2003/01/03 : keta

template<> 
inline void UserPreference::setValue<StringPtr>(CFStringRef strKey, StringPtr	pstrBufferPtr) throw()
{
	//
	setValue<ConstStringPtr>(strKey,pstrBufferPtr);
}
*/
/*
	ANZXw : public
	      ֐ : UserPreference::setValue<ConstStringPtr>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi Pascal  j
	         : strKey        L[
	               strValue      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
/*
template<> 
inline 
void	UserPreference::setValue<ConstStringPtr>(CFStringRef strKey, ConstStringPtr PSTR_BUFFER_PTR) throw()
{
	//ϐ錾
	CFStringRef									strValue;

	//
	strValue = ::CFStringCreateWithPascalString(kCFAllocatorDefault,
												PSTR_BUFFER_PTR,
												::CFStringGetSystemEncoding());
	setCFObject(strKey,
				strValue);
	if(NULL != strValue)
		::CFRelease(strValue);
}
*/

template<> 
inline void UserPreference::setValue<StringPtr>(CFStringRef strKey, StringPtr	pstrBufferPtr) throw()
{
	//ϐ錾
	CFStringRef strValue;

	//
	strValue = ::CFStringCreateWithPascalString(kCFAllocatorDefault,
                                                    pstrBufferPtr,
                                                    ::CFStringGetSystemEncoding());
	setCFObject(strKey, strValue);
	if(NULL != strValue)
		::CFRelease(strValue);
}

template<> 
inline void UserPreference::setValue<ConstStringPtr>(CFStringRef strKey, ConstStringPtr	pstrBufferPtr) throw()
{
	//ϐ錾
	CFStringRef strValue;
	
	//
	strValue = ::CFStringCreateWithPascalString(kCFAllocatorDefault,
												pstrBufferPtr,
												::CFStringGetSystemEncoding());
	setCFObject(strKey, strValue);
	if(NULL != strValue)
		::CFRelease(strValue);
}


/*
	ANZXw : public
	      ֐ : UserPreference::set<bool>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi bool  j
	         : strKey        L[
	               bValue        ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<bool>(CFStringRef	strKey,
																		   bool			bValue) throw()
{
	//
	setBoolean(strKey,
			   bValue);
}

/*
	ANZXw : public
	      ֐ : UserPreference::set<signed char>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi signed char  j
	         : strKey        L[
	               si8Value      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<signed char>(CFStringRef	strKey,
																				  signed char	si8Value) throw()
{
	//ϐ錾
	CFIndex										si32Value = si8Value;

	//
	setInteger(strKey,
			   si32Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::set<short>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi short  j
	         : strKey        L[
	               si8Value      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<short>(CFStringRef	strKey,
																			short		si16Value) throw()
{
	//ϐ錾
	//CFIndex si32Value = si16Value;

	//
	setInteger(strKey,
			   si16Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::set<long>
	        @\ : wL[Ɛݒl̑gݍ킹ǉi long  j
	         : strKey        L[
	               si8Value      ݒlւ̎Q
	      ߂l : 
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
template<> 
inline 
void										UserPreference::setValue<long>(CFStringRef	strKey,
																		   long			si32Value) throw()
{
	//
	setInteger(strKey,
			   si32Value);
}

/*
	ANZXw : public
	      ֐ : UserPreference::exists
	        @\ : wL[ɑΉݒl݂邩
	         : strKey        L[
	      ߂l : true  c ݂
	               false c ݂Ȃ
	        O : 
	        l : 1.  strKey ݒt@Cɑ݂ȂꍇAڂǉ
*/
inline 
bool										UserPreference::exists(CFStringRef	strKey) throw()
{
	//ϐ錾
	bool										bIsBoolean;
	bool										bIsInteger;
	bool										bIsCFObject;
	bool										bValue;
	CFIndex										si32Value;
	CFPropertyListRef							cfValue;

	//
	bIsBoolean  = getBooleanIfExists(strKey,
									 bValue);
	bIsInteger  = getIntegerIfExists(strKey,
									 si32Value);
	bIsCFObject = copyCFObjectIfExists(strKey,
									   cfValue);
	if(bIsCFObject)
		::CFRelease(cfValue);
	return (bIsBoolean || bIsInteger || bIsCFObject);
};

/*
	ANZXw : protected
	      ֐ : UserPreference::getApplicationID
	        @\ : AvP[Vʎq擾֐
	         : 
	      ߂l : AvP[Vʎq
	        O : 
	        l : 1. ֐߂l ::CFRelease() API ŉȂ
	               2. AvP[Vʎq͐ݒt@ĈɎgp
*/


#endif	//__USERPREFERENCE__