#include <vector>
#include "FileReference.h"



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	݂Ȃt@CwFSRef͍Ȃ߁A
	FSRefw肵ăCX^XB
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FileReference::FileReference( const FSRef &in ) : mFileRef( in )
{

}



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	݂Ȃt@CwFSRef͍Ȃ߁A
	邩ȂȂꍇ̓RXgN^ł͂Ȃ
	static\bhŒTă|C^𓾂B
	
	pX͑ʖځApXŋLqꍇ͉xĂяoƁB
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FileRefPtr FileReference::Find( const UniString &name, const FSRef *parent )
{
	OSErr	result;
	FSRef	p = GetApplicationFolderFSRef();
	FSRef	newFSRef;
	
	// ftHgNULLAFSRefnȂAvtH_
	if( parent == NULL )
		parent = &p;

	result =
	FSMakeFSRefUnicode
	(
		parent,
		name.length(),
		name.str(),
		kTextEncodingUnknown,
		&newFSRef		
	);
	
	// Ȃ
	if( result != noErr )
		return FileRefPtr();
	
	else
		return FileRefPtr( new FileReference( newFSRef ) );
}

/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	݂Ȃt@CwFSRef͍Ȃ߁A
	邩ȂȂꍇ̓RXgN^ł͂Ȃ
	static\bhŒTă|C^𓾂B
	
	PKŵݑΉ
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FileRefPtr FileReference::Find( const UniString &folder, const UniString &file, const FSRef *parent )
{
	FileRefPtr	FolderRef = Find( folder, parent );
	
	// Ȃ
	if( FolderRef.get() == NULL )
		return FileRefPtr();
	
	return Find( file, FolderRef->GetFSRefPtr() );
}



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	Av̂tH_̂𓾂B
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FSRef FileReference::GetApplicationFolderFSRef()
{
	FSRef			currentFSRef;
	ProcessSerialNumber	PSN;
	
	// ܂AvFSRef𓾂
	MacGetCurrentProcess( &PSN );
	GetProcessBundleLocation( &PSN, &currentFSRef );
	
	return GetParentFSRef( currentFSRef );
}

/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	^FSRef̐eFSRef𓾂B
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FSRef FileReference::GetParentFSRef( const FSRef &currentFSRef )
{
	FSRef			parentFSRef;
	FSSpec			fsp;
	HFSUniStr255		hfsName;
	FSCatalogInfo		catalogInfo;
	
	// FSRef(currentRef)̐eFSRef𓾂@
	FSGetCatalogInfo
	(
		&currentFSRef,
		kFSCatInfoNone,
		&catalogInfo,
		&hfsName,
		&fsp,
		&parentFSRef
	);
	
	return parentFSRef;
}



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	FSRefւ̈Öق̕ϊ
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/

FileReference::operator FSRef()
{
	return mFileRef;
}


FileReference::operator FSRef*()
{
	return &mFileRef;
}

FSRef FileReference::GetFSRef()
{
	return mFileRef;
}

FSRef *FileReference::GetFSRefPtr()
{
	return &mFileRef;
}


/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	FSSpecւ̈Öق̕ϊ
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/

FSSpec FileReference::GetFSSpec()
{
	FSRef			parentFSRef;
	FSSpec			fsp;
	HFSUniStr255		hfsName;
	FSCatalogInfo		catalogInfo;
	OSErr			result;
	
	result = FSGetCatalogInfo
	(
		&mFileRef,
		kFSCatInfoNone,
		&catalogInfo,
		&hfsName,
		&fsp,
		&parentFSRef
	);
	
	return fsp;
}

FileReference::operator FSSpec()
{
	return GetFSSpec();
}



CFStringPtr FileReference::GetPath( CFURLPathStyle PathStyle )
{
	CFURLRef url = CFURLCreateFromFSRef( kCFAllocatorDefault, &mFileRef );
	CFStringRef cfString = NULL;

	if( url == NULL )
		return CFStringPtr();

	cfString = CFURLCopyFileSystemPath( url, PathStyle );

		
	cfstring	*theString = new cfstring( cfString );
		
	CFRelease( cfString );
	CFRelease( url );

	return CFStringPtr( theString );
}

/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	HFS Path𓾂
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
CFStringPtr FileReference::GetHFSPath()
{
	return GetPath( kCFURLHFSPathStyle );
}


/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	POSIX Path𓾂
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
CFStringPtr FileReference::GetPOSIXPath()
{
	return GetPath( kCFURLPOSIXPathStyle );
}



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	Windows Path𓾂
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
CFStringPtr FileReference::GetWindowsPath()
{
	return GetPath( kCFURLWindowsPathStyle );
}


/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	HFS Path𓾂ÂQ
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
CFStringPtr FileReference::GetHFSPathManually()
{
	std::vector<HFSUniStr255>	names;
	OSStatus	result = noErr;
	FSCatalogInfo info = {};
	FSRef	localRef = mFileRef;
	
	CFMutableStringRef	path = CFStringCreateMutable
	(
		kCFAllocatorDefault,
		0
	);
	
	UniChar	inSepChar;
	CFStringGetCharacters( CFSTR( ":" ), CFRangeMake( 0, 1 ), &inSepChar );
	
	do
	{ 
        	HFSUniStr255 name; 
        	
        	result = FSGetCatalogInfo
        	(
        		&localRef,
        		kFSCatInfoNodeID,
        		&info,
        		&name,
        		nil,
        		&localRef 
        	);

		if ( result == noErr )
			names.push_back( name );
	}
	while ( result == noErr && info.nodeID != fsRtDirID );

	for ( int i = names.size() - 1; i >= 0; --i )
	{
		CFStringAppendCharacters
		(
			path,
			names[ i ].unicode,
			names[ i ].length
		);
		
		if ( i > 0 )
			CFStringAppendCharacters( path, &inSepChar, 1 ); 
	}
	
	cfstring	*p = new cfstring( path );
	CFRelease( path );

	return CFStringPtr( p );
}


/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	POSIX Path𓾂ÂQ
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
CFStringPtr FileReference::GetPOSIXPathManually()
{
	UInt32	maxPathSize = 16384;
	UInt8	*path = new UInt8[maxPathSize];
	OSErr	result;
	
	result = FSRefMakePath( &mFileRef, path, maxPathSize );
	if( result != noErr )
		return CFStringPtr();
	
	cfstring	*p = new cfstring
	(
		reinterpret_cast<const char *>(path),
		kCFStringEncodingUTF8
	);	
	delete path;
	
	return CFStringPtr( p );
}



/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	fopen
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/
FILE *FileReference::fopen( const char *mode )
{
	FILE	*file;
	CFStringPtr path;

	#ifdef __APPLE_CC__
		//path = GetPOSIXPath();
		path = GetPOSIXPathManually();
		file = ::fopen( path->cString( kCFStringEncodingUTF8 ), mode );
	#else		// CodeWarrior?
		//path = GetHFSPath();
		path = GetHFSPathManually();
		file = ::fopen( path->cString(), mode );	
	#endif

	return file;
}





/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	ȉAȈՌ^UnicodeNX

	FSRefUniChar[]̔zgꍇɁB
	
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/



CFStringEncoding UniString::mDefaultEncoding = kCFStringEncodingShiftJIS;


/*[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
	RXgN^
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[*/

UniString::UniString() : mString(NULL), mLength(0)
{
	// gȂ( private )
}


UniString::UniString( const char *in )
{
	CFStringRef	str;
	
	str =	CFStringCreateWithCString
	(
		NULL,
		in,
		mDefaultEncoding
	);

	mLength = static_cast<UniCharCount>(CFStringGetLength( str ));
	mString = new UniChar[mLength];
	CFStringGetCharacters( str, CFRangeMake( 0, mLength ), mString );
	
	CFRelease( str );
}

UniString::UniString( ConstStringPtr in )
{
	CFStringRef	str;
	
	str = CFStringCreateWithPascalString
	(
		kCFAllocatorDefault,
		in,
		mDefaultEncoding
	);

	mLength = static_cast<UniCharCount>(CFStringGetLength( str ));
	mString = new UniChar[mLength];
	CFStringGetCharacters( str, CFRangeMake( 0, mLength ), mString );
	
	CFRelease( str );
}


/*---------------------------------------------------------
	fXgN^
---------------------------------------------------------*/

UniString::~UniString()
{
	release();
}



/*---------------------------------------------------------
	Ăf[^
---------------------------------------------------------*/

void UniString::release()
{
	if( mString != NULL )
	{
		delete [] mString;

		mString = NULL;
		mLength = 0;		
	}
}



/*---------------------------------------------------------
	ANZX
---------------------------------------------------------*/

inline UniCharCount UniString::length() const
{
	return mLength;
}


inline UniChar *UniString::str() const
{
	return mString;
}
