#ifndef __FILEREFERENCE__
#define __FILEREFERENCE__

#include <stdio.h>
#include <memory>	// std::auto_ptr

#include "cfstring.h"
//#include "smart_ptr.h"

class FileReference;

typedef std::auto_ptr<FileReference> FileRefPtr;
//typedef smart_ptr<FileReference> FileRefPtr;

/*---------------------------------------------------------
	ȈՌ^UnicodeNX
---------------------------------------------------------*/

class UniString
{
public:
	UniString( const char * );
	UniString( ConstStringPtr );
						
	virtual ~UniString();

	UniCharCount length() const;
	UniChar *str() const;
	
	static CFStringEncoding mDefaultEncoding;
	
protected:
	
	void release();

private:
	UniString();
	UniString( const std::string & );
//	UniString( const UniString & );
	UniString &operator = ( const std::string & );
	UniString &operator = ( const UniString & );

	UniChar *mString;
	UniCharCount mLength;
};


class FileReference
{
public:
	FileReference( const FSRef &in );
	virtual ~FileReference(){};

	operator	FSRef();
	operator	FSSpec();
	operator	FSRef*();
	operator	FSSpec*();
	
	FSRef	GetFSRef();
	FSSpec	GetFSSpec();
	FSRef	*GetFSRefPtr();
	
	CFStringPtr GetHFSPath();
	CFStringPtr GetPOSIXPath();
	CFStringPtr GetWindowsPath();
	CFStringPtr GetPath( CFURLPathStyle );
	
	CFStringPtr GetHFSPathManually();
	CFStringPtr GetPOSIXPathManually();
	
	FILE		*fopen( const char *mode );
	
	static FSRef GetParentFSRef( const FSRef &currentFSRef );
	static FSRef GetApplicationFolderFSRef();
	
	static FileRefPtr Find( const UniString &name, const FSRef *parent = NULL );
	static FileRefPtr Find( const UniString &name1, const UniString &name2, const FSRef *parent = NULL );



private:
	FSRef	mFileRef;
};

#endif