#include <string.h>
#include "cfstring.h"



/*--------------------------------------------------------------------------------
	ftHgRXgN^
--------------------------------------------------------------------------------*/

cfstring::cfstring() :	mReference(nil)
{
	mCString = NULL;
}



/*--------------------------------------------------------------------------------
	Rs[RXgN^
--------------------------------------------------------------------------------*/

cfstring::cfstring( const cfstring &in )
{
	mReference = 
	CFStringCreateCopy
	(
		kCFAllocatorDefault,
		in.mReference
	);

	mCString = NULL;
}


cfstring::cfstring( const std::string &in, CFStringEncoding encoding )
{
	mReference = 
	CFStringCreateWithBytes
	(
		kCFAllocatorDefault,
		reinterpret_cast<const unsigned char *>( in.c_str() ),
		in.length(),
		encoding,
		false
	);		

	mCString = NULL;
}


cfstring::cfstring( const char *in, CFStringEncoding encoding )
{
	mReference = 
	CFStringCreateWithBytes
	(
		kCFAllocatorDefault,
		reinterpret_cast<const unsigned char *>( in ),
		strlen( in ),
		encoding,
		false
	);		

	mCString = NULL;
}


cfstring::cfstring( ConstStringPtr in, CFStringEncoding encoding )
{
	mReference = 
	CFStringCreateWithPascalString
	(
		kCFAllocatorDefault,
		in,
		encoding
	);

	mCString = NULL;
}


cfstring::cfstring( const CFStringRef in )
{
	mReference = CFStringCreateCopy( kCFAllocatorDefault, in );

	CFIndex  len   = CFStringGetLength( mReference );

	mCString = NULL;
}





/*--------------------------------------------------------------------------------
	fXgN^
--------------------------------------------------------------------------------*/

cfstring::~cfstring()
{
	release();
}



/*--------------------------------------------------------------------------------
	
--------------------------------------------------------------------------------*/


cfstring &cfstring::operator=( const cfstring &in )
{
	release();

	mReference =
	CFStringCreateCopy
	(
		kCFAllocatorDefault,
		in.mReference
	);
	
	return *this;
}


cfstring &cfstring::operator=( const std::string in )
{
	release();

	mReference =
	CFStringCreateWithBytes
	(
		kCFAllocatorDefault,
		reinterpret_cast<const unsigned char *>( in.c_str() ),
		in.length(),
		kCFStringEncodingShiftJIS,
		false
	);
					
	return *this;
}


cfstring &cfstring::operator=( ConstStringPtr in )
{
	release();

	mReference =
	CFStringCreateWithPascalString
	(
		kCFAllocatorDefault,
		in,
		kCFStringEncodingShiftJIS
	);
	
	return *this;
}


cfstring &cfstring::operator=( const CFStringRef in )
{
	release();

	CFStringCreateCopy( kCFAllocatorDefault, in );
	
	return *this;
}



cfstring &cfstring::set( const std::string in, CFStringEncoding encoding )
{
	release();

	mReference =
	CFStringCreateWithBytes
	(
		kCFAllocatorDefault,
		reinterpret_cast<const unsigned char *>( in.c_str() ),
		in.length(),
		encoding,
		false
	);
					
	return *this;
}


/*--------------------------------------------------------------------------------
	mReference
--------------------------------------------------------------------------------*/

void cfstring::release()
{
	if( mReference != nil )
	{
		CFRelease( mReference );
		mReference = nil;
	}

	if( mCString != NULL )
	{
		delete mCString;
		mCString = NULL;
	}
}



/*--------------------------------------------------------------------------------
	ANZX
--------------------------------------------------------------------------------*/

UniChar	cfstring::operator [] ( CFIndex inIndex ) const
{
	return CFStringGetCharacterAtIndex( mReference, inIndex );
}


/*--------------------------------------------------------------------------------
	Pascal𓾂
--------------------------------------------------------------------------------*/

void cfstring::pascalString( StringPtr out, CFStringEncoding encoding ) const
{
	CFStringGetPascalString
	(
		mReference,
		out,
		255,
		encoding
	);
}


cfstring::operator ConstStringPtr()
{
	pascalString( mPascalString );

	return mPascalString;
}



/*--------------------------------------------------------------------------------
	C𓾂
--------------------------------------------------------------------------------*/

void cfstring::cString( char *out, size_t size, CFStringEncoding encoding )
{
	CFStringGetCString
	(
		mReference,
		out,
		size,
		encoding
	);
}



/*--------------------------------------------------------------------------------
	C𓾂
--------------------------------------------------------------------------------*/

char *cfstring::cString( CFStringEncoding encoding )
{
	UniCharCount	length = static_cast<UniCharCount>(CFStringGetLength( mReference ));
	
	if( mCString != NULL )
	{
		delete mCString;
	}
	
	int max = CFStringGetMaximumSizeForEncoding( length, encoding );
	mCString = new char [max + 1];

	CFStringGetCString
	(
		mReference,
		mCString,
		max,
		encoding
	);


	return mCString;
}



/*--------------------------------------------------------------------------------
	STL string𓾂
--------------------------------------------------------------------------------*/


cfstring::operator std::string()
{
	return stl_string();
}


std::string cfstring::stl_string( CFStringEncoding encoding )
{
	std::string	str;
	CFIndex		length;
	char		*cstr;
	
	length = CFStringGetLength( mReference );
	length = length * 2 + 1;
	cstr = new char[length];

	cString( cstr, length, encoding );

	// std::stringɃRs[āAzJ
	str = cstr;
	delete [] cstr;

	return str;
}



