
#ifndef __cfstring
#define __cfstring

#include <CFString.h>
#include <string>

#include <memory>	// std::auto_ptr
//#include "smart_ptr.h"

class cfstring;

typedef std::auto_ptr<cfstring> CFStringPtr;
//typedef smart_ptr<cfstring> CFStringPtr;


class cfstring
{
public:
	cfstring();
	cfstring( const cfstring &in );
	cfstring( const std::string &in, CFStringEncoding encoding = kCFStringEncodingShiftJIS );
	cfstring( const char *in, CFStringEncoding encoding = kCFStringEncodingShiftJIS );
	cfstring( ConstStringPtr in, CFStringEncoding encoding = kCFStringEncodingShiftJIS );
	cfstring( const CFStringRef in );
						
	virtual ~cfstring();

	operator ConstStringPtr();
	operator std::string();
		

	cfstring &		operator = ( const cfstring &in );
	cfstring &		operator = ( const std::string in );
	cfstring &		operator = ( ConstStringPtr in );
	cfstring &		operator = ( const CFStringRef in );

	UniChar		operator [] ( CFIndex inIndex ) const;


	cfstring &		set( const std::string in, CFStringEncoding encoding = kCFStringEncodingShiftJIS );

	void	pascalString
	(
		StringPtr out,
		CFStringEncoding encode = kCFStringEncodingShiftJIS
	) const;

	void	cString
	(
		char *out,
		size_t size,
		CFStringEncoding encode = kCFStringEncodingShiftJIS
	);

	char	*cString
	(
		CFStringEncoding encode = kCFStringEncodingShiftJIS
	);

	std::string stl_string
	(
		CFStringEncoding encode = kCFStringEncodingShiftJIS
	);
						
protected:
	
	void release();

private:
	
	CFStringRef	mReference;
	Str255		mPascalString;
	char			*mCString;
};






#endif